/**
 * Document Understanding API
 * Document AI helps customers perform various analysis on their documents. If a customer has lots of documents, they can process them in batch using asynchronous API endpoints.
 * OpenAPI spec version: 20221109
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Request payload to add lock to the resource.
 */
export interface AddModelLockDetails {
    /**
     * Type of the lock.
     */
    "type": AddModelLockDetails.Type;
    /**
     * The ID of the resource that is locking this resource. Indicates that deleting this resource will remove the lock.
     */
    "relatedResourceId"?: string;
    /**
     * A message added by the creator of the lock. This is typically used to give an indication of why the resource is locked.
     */
    "message"?: string;
}
export declare namespace AddModelLockDetails {
    enum Type {
        Full = "FULL",
        Delete = "DELETE"
    }
    function getJsonObj(obj: AddModelLockDetails): object;
    function getDeserializedJsonObj(obj: AddModelLockDetails): object;
}
