/**
 * Speech API
 * The OCI Speech Service harnesses the power of spoken language by allowing developers to easily convert file-based data containing human speech into highly accurate text transcriptions.
 * OpenAPI spec version: 20220101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Details of the ASR model used by the realtime speech service.
 */
export interface RealtimeModelDetails {
    /**
     * Model Domain.
     */
    "domain"?: RealtimeModelDetails.Domain;
    /**
     * Locale value as per given in [https://datatracker.ietf.org/doc/html/rfc5646].
     * - en-US: English - United States
     * - es-ES: Spanish - Spain
     * - pt-BR: Portuguese - Brazil
     * - en-GB: English - Great Britain
     * - en-AU: English - Australia
     * - en-IN: English - India
     * - hi-IN: Hindi - India
     * - fr-FR: French - France
     * - de-DE: German - Germany
     * - it-IT: Italian - Italy
     *
     */
    "languageCode"?: string;
}
export declare namespace RealtimeModelDetails {
    enum Domain {
        Generic = "GENERIC",
        Medical = "MEDICAL"
    }
    function getJsonObj(obj: RealtimeModelDetails): object;
    function getDeserializedJsonObj(obj: RealtimeModelDetails): object;
}
