/**
 * Oracle API Access Control
 * This service is used to restrict the control plane service apis; so that everybody won't be
able to access those apis.
There are two main resouces defined as a part of this service
1. PrivilegedApiControl: This is created by the customer which defines which service apis are
   controlled and who can access it.
2. PrivilegedApiRequest: This is a request object again created by the customer operators who           seek access to those privileged apis. After a request is obtained based on the                       PrivilegedAccessControl for which the api belongs to, either it can be approved so that the          requested person can execute the service apis or it will wait for the customer to approve it.

 * OpenAPI spec version: 20241130
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as requests from "./lib/request";
import * as models from "./lib/model";
import * as responses from "./lib/response";
import * as client from "./lib/client";
import * as apimetadata_waiter from "./lib/apimetadata-waiter";
import * as privilegedapicontrol_waiter from "./lib/privilegedapicontrol-waiter";
import * as privilegedapirequests_waiter from "./lib/privilegedapirequests-waiter";
import * as privilegedapiworkrequest_waiter from "./lib/privilegedapiworkrequest-waiter";
export { models };
export { requests };
export { responses };
export import ApiMetadataClient = client.ApiMetadataClient;
export import ApiMetadataWaiter = apimetadata_waiter.ApiMetadataWaiter;
export import PrivilegedApiControlClient = client.PrivilegedApiControlClient;
export import PrivilegedApiControlWaiter = privilegedapicontrol_waiter.PrivilegedApiControlWaiter;
export import PrivilegedApiRequestsClient = client.PrivilegedApiRequestsClient;
export import PrivilegedApiRequestsWaiter = privilegedapirequests_waiter.PrivilegedApiRequestsWaiter;
export import PrivilegedApiWorkRequestClient = client.PrivilegedApiWorkRequestClient;
export import PrivilegedApiWorkRequestWaiter = privilegedapiworkrequest_waiter.PrivilegedApiWorkRequestWaiter;
