/**
 * Oracle API Access Control
 * This service is used to restrict the control plane service apis; so that everybody won't be
able to access those apis.
There are two main resouces defined as a part of this service
1. PrivilegedApiControl: This is created by the customer which defines which service apis are
   controlled and who can access it.
2. PrivilegedApiRequest: This is a request object again created by the customer operators who           seek access to those privileged apis. After a request is obtained based on the                       PrivilegedAccessControl for which the api belongs to, either it can be approved so that the          requested person can execute the service apis or it will wait for the customer to approve it.

 * OpenAPI spec version: 20241130
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * It contains appprovers details such as who approved it, when he approved and any details the approver would have entered as a part of approval process.
 */
export interface ApproverDetail {
    /**
     * The userId of the approver.
     */
    "approverId"?: string;
    /**
     * The action done by the approver.
     */
    "approvalAction"?: string;
    /**
     * Comment specified by the approver of the request.
     */
    "approvalComment"?: string;
    /**
     * Time when the privilegedApi request was authorized by the customer in [RFC 3339](https://tools.ietf.org/html/rfc3339) timestamp format.Example: '2020-05-22T21:10:29.600Z'
     *
     */
    "timeOfAuthorization"?: Date;
    /**
     * Time for when the privilegedApi request should start that is authorized by the customer in [RFC 3339](https://tools.ietf.org/html/rfc3339) timestamp format.Example: '2020-05-22T21:10:29.600Z'
     *
     */
    "timeApprovedForAccess"?: Date;
}
export declare namespace ApproverDetail {
    function getJsonObj(obj: ApproverDetail): object;
    function getDeserializedJsonObj(obj: ApproverDetail): object;
}
