/**
 * Oracle API Access Control
 * This service is used to restrict the control plane service apis; so that everybody won't be
able to access those apis.
There are two main resouces defined as a part of this service
1. PrivilegedApiControl: This is created by the customer which defines which service apis are
   controlled and who can access it.
2. PrivilegedApiRequest: This is a request object again created by the customer operators who           seek access to those privileged apis. After a request is obtained based on the                       PrivilegedAccessControl for which the api belongs to, either it can be approved so that the          requested person can execute the service apis or it will wait for the customer to approve it.

 * OpenAPI spec version: 20241130
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as ActionType from "./action-type";
export import ActionType = ActionType.ActionType;
import * as ApiMetadata from "./api-metadata";
export import ApiMetadata = ApiMetadata.ApiMetadata;
import * as ApiMetadataByEntityTypeCollection from "./api-metadata-by-entity-type-collection";
export import ApiMetadataByEntityTypeCollection = ApiMetadataByEntityTypeCollection.ApiMetadataByEntityTypeCollection;
import * as ApiMetadataByEntityTypeSummary from "./api-metadata-by-entity-type-summary";
export import ApiMetadataByEntityTypeSummary = ApiMetadataByEntityTypeSummary.ApiMetadataByEntityTypeSummary;
import * as ApiMetadataCollection from "./api-metadata-collection";
export import ApiMetadataCollection = ApiMetadataCollection.ApiMetadataCollection;
import * as ApiMetadataSummary from "./api-metadata-summary";
export import ApiMetadataSummary = ApiMetadataSummary.ApiMetadataSummary;
import * as ApprovePrivilegedApiRequestDetails from "./approve-privileged-api-request-details";
export import ApprovePrivilegedApiRequestDetails = ApprovePrivilegedApiRequestDetails.ApprovePrivilegedApiRequestDetails;
import * as ApproverDetail from "./approver-detail";
export import ApproverDetail = ApproverDetail.ApproverDetail;
import * as ChangePrivilegedApiControlCompartmentDetails from "./change-privileged-api-control-compartment-details";
export import ChangePrivilegedApiControlCompartmentDetails = ChangePrivilegedApiControlCompartmentDetails.ChangePrivilegedApiControlCompartmentDetails;
import * as ClosePrivilegedApiRequestDetails from "./close-privileged-api-request-details";
export import ClosePrivilegedApiRequestDetails = ClosePrivilegedApiRequestDetails.ClosePrivilegedApiRequestDetails;
import * as CreatePrivilegedApiControlDetails from "./create-privileged-api-control-details";
export import CreatePrivilegedApiControlDetails = CreatePrivilegedApiControlDetails.CreatePrivilegedApiControlDetails;
import * as CreatePrivilegedApiRequestDetails from "./create-privileged-api-request-details";
export import CreatePrivilegedApiRequestDetails = CreatePrivilegedApiRequestDetails.CreatePrivilegedApiRequestDetails;
import * as OperationStatus from "./operation-status";
export import OperationStatus = OperationStatus.OperationStatus;
import * as OperationType from "./operation-type";
export import OperationType = OperationType.OperationType;
import * as PrivilegedApiControl from "./privileged-api-control";
export import PrivilegedApiControl = PrivilegedApiControl.PrivilegedApiControl;
import * as PrivilegedApiControlCollection from "./privileged-api-control-collection";
export import PrivilegedApiControlCollection = PrivilegedApiControlCollection.PrivilegedApiControlCollection;
import * as PrivilegedApiControlSummary from "./privileged-api-control-summary";
export import PrivilegedApiControlSummary = PrivilegedApiControlSummary.PrivilegedApiControlSummary;
import * as PrivilegedApiDetails from "./privileged-api-details";
export import PrivilegedApiDetails = PrivilegedApiDetails.PrivilegedApiDetails;
import * as PrivilegedApiRequest from "./privileged-api-request";
export import PrivilegedApiRequest = PrivilegedApiRequest.PrivilegedApiRequest;
import * as PrivilegedApiRequestCollection from "./privileged-api-request-collection";
export import PrivilegedApiRequestCollection = PrivilegedApiRequestCollection.PrivilegedApiRequestCollection;
import * as PrivilegedApiRequestOperationDetails from "./privileged-api-request-operation-details";
export import PrivilegedApiRequestOperationDetails = PrivilegedApiRequestOperationDetails.PrivilegedApiRequestOperationDetails;
import * as PrivilegedApiRequestSeverity from "./privileged-api-request-severity";
export import PrivilegedApiRequestSeverity = PrivilegedApiRequestSeverity.PrivilegedApiRequestSeverity;
import * as PrivilegedApiRequestSummary from "./privileged-api-request-summary";
export import PrivilegedApiRequestSummary = PrivilegedApiRequestSummary.PrivilegedApiRequestSummary;
import * as RejectPrivilegedApiRequestDetails from "./reject-privileged-api-request-details";
export import RejectPrivilegedApiRequestDetails = RejectPrivilegedApiRequestDetails.RejectPrivilegedApiRequestDetails;
import * as RevokePrivilegedApiRequestDetails from "./revoke-privileged-api-request-details";
export import RevokePrivilegedApiRequestDetails = RevokePrivilegedApiRequestDetails.RevokePrivilegedApiRequestDetails;
import * as SortOrder from "./sort-order";
export import SortOrder = SortOrder.SortOrder;
import * as UpdatePrivilegedApiControlDetails from "./update-privileged-api-control-details";
export import UpdatePrivilegedApiControlDetails = UpdatePrivilegedApiControlDetails.UpdatePrivilegedApiControlDetails;
import * as WorkRequest from "./work-request";
export import WorkRequest = WorkRequest.WorkRequest;
import * as WorkRequestError from "./work-request-error";
export import WorkRequestError = WorkRequestError.WorkRequestError;
import * as WorkRequestErrorCollection from "./work-request-error-collection";
export import WorkRequestErrorCollection = WorkRequestErrorCollection.WorkRequestErrorCollection;
import * as WorkRequestLogEntry from "./work-request-log-entry";
export import WorkRequestLogEntry = WorkRequestLogEntry.WorkRequestLogEntry;
import * as WorkRequestLogEntryCollection from "./work-request-log-entry-collection";
export import WorkRequestLogEntryCollection = WorkRequestLogEntryCollection.WorkRequestLogEntryCollection;
import * as WorkRequestResource from "./work-request-resource";
export import WorkRequestResource = WorkRequestResource.WorkRequestResource;
import * as WorkRequestResourceMetadataKey from "./work-request-resource-metadata-key";
export import WorkRequestResourceMetadataKey = WorkRequestResourceMetadataKey.WorkRequestResourceMetadataKey;
import * as WorkRequestSummary from "./work-request-summary";
export import WorkRequestSummary = WorkRequestSummary.WorkRequestSummary;
import * as WorkRequestSummaryCollection from "./work-request-summary-collection";
export import WorkRequestSummaryCollection = WorkRequestSummaryCollection.WorkRequestSummaryCollection;
