/**
 * Oracle API Access Control
 * This service is used to restrict the control plane service apis; so that everybody won't be
able to access those apis.
There are two main resouces defined as a part of this service
1. PrivilegedApiControl: This is created by the customer which defines which service apis are
   controlled and who can access it.
2. PrivilegedApiRequest: This is a request object again created by the customer operators who           seek access to those privileged apis. After a request is obtained based on the                       PrivilegedAccessControl for which the api belongs to, either it can be approved so that the          requested person can execute the service apis or it will wait for the customer to approve it.

 * OpenAPI spec version: 20241130
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The data to update a PrivilegedApiControl.
 */
export interface UpdatePrivilegedApiControlDetails {
    /**
     * Name of the privilegedApi control. Needs to be unique.
     */
    "displayName"?: string;
    /**
     * Description of the privilegedApi control.
     */
    "description"?: string;
    /**
     * resourceType for which the PrivilegedApiControl is applicable
     */
    "resourceType"?: string;
    /**
     * contains Resource details
     */
    "resources"?: Array<string>;
    /**
     * The OCID of the OCI Notification topic to publish messages related to this Delegation Control.
     */
    "notificationTopicId"?: string;
    /**
     * List of user IAM group ids who can approve an privilegedApi request associated with a target resource under the governance of this privilegedApi control.
     */
    "approverGroupIdList"?: Array<string>;
    /**
     * List of privileged operator operations. If Privileged API Managment is enabled for a resource it will be validated whether the operation done by the operator is a part of privileged operation.
     *
     */
    "privilegedOperationList"?: Array<model.PrivilegedApiDetails>;
    /**
     * Number of approvers required to approve an privilegedApi request. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "numberOfApprovers"?: number;
    /**
      * Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace.
  * For more information, see [Resource Tags](https://docs.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).
  * <p>
  Example: {@code {\"Department\": \"Finance\"}}
  *
      */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
      * Defined tags for this resource. Each key is predefined and scoped to a namespace.
  * For more information, see [Resource Tags](https://docs.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).
  * <p>
  Example: {@code {\"Operations\": {\"CostCenter\": \"42\"}}}
  *
      */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace UpdatePrivilegedApiControlDetails {
    function getJsonObj(obj: UpdatePrivilegedApiControlDetails): object;
    function getDeserializedJsonObj(obj: UpdatePrivilegedApiControlDetails): object;
}
