/**
 * Oracle API Access Control
 * This service is used to restrict the control plane service apis; so that everybody won't be
able to access those apis.
There are two main resouces defined as a part of this service
1. PrivilegedApiControl: This is created by the customer which defines which service apis are
   controlled and who can access it.
2. PrivilegedApiRequest: This is a request object again created by the customer operators who           seek access to those privileged apis. After a request is obtained based on the                       PrivilegedAccessControl for which the api belongs to, either it can be approved so that the          requested person can execute the service apis or it will wait for the customer to approve it.

 * OpenAPI spec version: 20241130
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A resource created or operated on by a work request.
 */
export interface WorkRequestResource {
    /**
     * The resource type that the work request affects.
     */
    "entityType": string;
    /**
     * The way in which this resource is affected by the operation tracked in the work request.
     * A resource being created, updated, or deleted remains in the IN_PROGRESS state until
     * work is complete for that resource, at which point it transitions to CREATED, UPDATED,
     * or DELETED, respectively.
     *
     */
    "actionType": model.ActionType;
    /**
     * An [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) or other unique identifier for the resource.
     */
    "identifier": string;
    /**
     * The URI path that you can use for a GET request to access the resource metadata.
     */
    "entityUri"?: string;
    /**
     * Additional information that helps to explain the resource.
     */
    "metadata"?: {
        [key: string]: string;
    };
}
export declare namespace WorkRequestResource {
    function getJsonObj(obj: WorkRequestResource): object;
    function getDeserializedJsonObj(obj: WorkRequestResource): object;
}
