/**
 * Oracle API Access Control
 * This service is used to restrict the control plane service apis; so that everybody won't be
able to access those apis.
There are two main resouces defined as a part of this service
1. PrivilegedApiControl: This is created by the customer which defines which service apis are
   controlled and who can access it.
2. PrivilegedApiRequest: This is a request object again created by the customer operators who           seek access to those privileged apis. After a request is obtained based on the                       PrivilegedAccessControl for which the api belongs to, either it can be approved so that the          requested person can execute the service apis or it will wait for the customer to approve it.

 * OpenAPI spec version: 20241130
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as GetApiMetadataRequest from "./get-api-metadata-request";
export import GetApiMetadataRequest = GetApiMetadataRequest.GetApiMetadataRequest;
import * as ListApiMetadataRequest from "./list-api-metadata-request";
export import ListApiMetadataRequest = ListApiMetadataRequest.ListApiMetadataRequest;
import * as ListApiMetadataByEntityTypesRequest from "./list-api-metadata-by-entity-types-request";
export import ListApiMetadataByEntityTypesRequest = ListApiMetadataByEntityTypesRequest.ListApiMetadataByEntityTypesRequest;
import * as ChangePrivilegedApiControlCompartmentRequest from "./change-privileged-api-control-compartment-request";
export import ChangePrivilegedApiControlCompartmentRequest = ChangePrivilegedApiControlCompartmentRequest.ChangePrivilegedApiControlCompartmentRequest;
import * as CreatePrivilegedApiControlRequest from "./create-privileged-api-control-request";
export import CreatePrivilegedApiControlRequest = CreatePrivilegedApiControlRequest.CreatePrivilegedApiControlRequest;
import * as DeletePrivilegedApiControlRequest from "./delete-privileged-api-control-request";
export import DeletePrivilegedApiControlRequest = DeletePrivilegedApiControlRequest.DeletePrivilegedApiControlRequest;
import * as GetPrivilegedApiControlRequest from "./get-privileged-api-control-request";
export import GetPrivilegedApiControlRequest = GetPrivilegedApiControlRequest.GetPrivilegedApiControlRequest;
import * as ListPrivilegedApiControlsRequest from "./list-privileged-api-controls-request";
export import ListPrivilegedApiControlsRequest = ListPrivilegedApiControlsRequest.ListPrivilegedApiControlsRequest;
import * as UpdatePrivilegedApiControlRequest from "./update-privileged-api-control-request";
export import UpdatePrivilegedApiControlRequest = UpdatePrivilegedApiControlRequest.UpdatePrivilegedApiControlRequest;
import * as ApprovePrivilegedApiRequestRequest from "./approve-privileged-api-request-request";
export import ApprovePrivilegedApiRequestRequest = ApprovePrivilegedApiRequestRequest.ApprovePrivilegedApiRequestRequest;
import * as ClosePrivilegedApiRequestRequest from "./close-privileged-api-request-request";
export import ClosePrivilegedApiRequestRequest = ClosePrivilegedApiRequestRequest.ClosePrivilegedApiRequestRequest;
import * as CreatePrivilegedApiRequestRequest from "./create-privileged-api-request-request";
export import CreatePrivilegedApiRequestRequest = CreatePrivilegedApiRequestRequest.CreatePrivilegedApiRequestRequest;
import * as GetPrivilegedApiRequestRequest from "./get-privileged-api-request-request";
export import GetPrivilegedApiRequestRequest = GetPrivilegedApiRequestRequest.GetPrivilegedApiRequestRequest;
import * as ListPrivilegedApiRequestsRequest from "./list-privileged-api-requests-request";
export import ListPrivilegedApiRequestsRequest = ListPrivilegedApiRequestsRequest.ListPrivilegedApiRequestsRequest;
import * as RejectPrivilegedApiRequestRequest from "./reject-privileged-api-request-request";
export import RejectPrivilegedApiRequestRequest = RejectPrivilegedApiRequestRequest.RejectPrivilegedApiRequestRequest;
import * as RevokePrivilegedApiRequestRequest from "./revoke-privileged-api-request-request";
export import RevokePrivilegedApiRequestRequest = RevokePrivilegedApiRequestRequest.RevokePrivilegedApiRequestRequest;
import * as CancelWorkRequestRequest from "./cancel-work-request-request";
export import CancelWorkRequestRequest = CancelWorkRequestRequest.CancelWorkRequestRequest;
import * as GetWorkRequestRequest from "./get-work-request-request";
export import GetWorkRequestRequest = GetWorkRequestRequest.GetWorkRequestRequest;
import * as ListWorkRequestErrorsRequest from "./list-work-request-errors-request";
export import ListWorkRequestErrorsRequest = ListWorkRequestErrorsRequest.ListWorkRequestErrorsRequest;
import * as ListWorkRequestLogsRequest from "./list-work-request-logs-request";
export import ListWorkRequestLogsRequest = ListWorkRequestLogsRequest.ListWorkRequestLogsRequest;
import * as ListWorkRequestsRequest from "./list-work-requests-request";
export import ListWorkRequestsRequest = ListWorkRequestsRequest.ListWorkRequestsRequest;
