/**
 * Big Data Service API
 * REST API for Oracle Big Data Service. Use this API to build, deploy, and manage fully elastic Big Data Service clusters. Build on Hadoop, Spark and Data Science distributions, which can be fully integrated with existing enterprise data in Oracle Database and Oracle applications.

 * OpenAPI spec version: 20190531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A report of the host capacity within an availability domain that is available for you to create bds clusters. Host capacity is the physical infrastructure that resources such as compute instances run on. Use the capacity report to determine whether sufficient capacity is available for a shape before you create a bds cluster or change the shape of a bds cluster.
 *
 */
export interface BdsCapacityReport {
    /**
     * The OCID for the compartment. This should always be the root compartment.
     */
    "compartmentId": string;
    /**
     * Information about the capacity of each requested shape.
     */
    "shapeAvailabilities": Array<model.CapacityReportShapeAvailability>;
    /**
     * The time the report was created, shown as an RFC 3339 formatted datetime string.
     */
    "timeCreated": Date;
}
export declare namespace BdsCapacityReport {
    function getJsonObj(obj: BdsCapacityReport): object;
    function getDeserializedJsonObj(obj: BdsCapacityReport): object;
}
