/**
 * Big Data Service API
 * REST API for Oracle Big Data Service. Use this API to build, deploy, and manage fully elastic Big Data Service clusters. Build on Hadoop, Spark and Data Science distributions, which can be fully integrated with existing enterprise data in Oracle Database and Oracle applications.

 * OpenAPI spec version: 20190531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details about the given BDS type of software update. Previously known as Micro Service Patch.
 */
export interface BdsSoftwareUpdate extends model.SoftwareUpdate {
    /**
     * The due date for the software update. Big Data Service will be updated automatically after this date.
     */
    "timeDue": Date;
    "softwareUpdateType": string;
}
export declare namespace BdsSoftwareUpdate {
    function getJsonObj(obj: BdsSoftwareUpdate, isParentJsonObj?: boolean): object;
    const softwareUpdateType = "BDS";
    function getDeserializedJsonObj(obj: BdsSoftwareUpdate, isParentJsonObj?: boolean): object;
}
