/**
 * Big Data Service API
 * REST API for Oracle Big Data Service. Use this API to build, deploy, and manage fully elastic Big Data Service clusters. Build on Hadoop, Spark and Data Science distributions, which can be fully integrated with existing enterprise data in Oracle Database and Oracle applications.

 * OpenAPI spec version: 20190531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Detailed information about the availabilities of a shape in each domain.
 */
export interface CapacityReportShapeAvailability {
    /**
     * The shape that the capacity report was requested for.
     */
    "shape": string;
    "shapeConfig"?: model.ShapeConfigDetails;
    /**
     * Information about the capacity in each domain.
     */
    "domainLevelCapacityReports": Array<model.DomainTypeCapacityReport>;
}
export declare namespace CapacityReportShapeAvailability {
    function getJsonObj(obj: CapacityReportShapeAvailability): object;
    function getDeserializedJsonObj(obj: CapacityReportShapeAvailability): object;
}
