/**
 * Big Data Service API
 * REST API for Oracle Big Data Service. Use this API to build, deploy, and manage fully elastic Big Data Service clusters. Build on Hadoop, Spark and Data Science distributions, which can be fully integrated with existing enterprise data in Oracle Database and Oracle applications.

 * OpenAPI spec version: 20190531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The data to create a report of available BDS capacity.
 */
export interface CreateBdsCapacityReportDetails {
    /**
     * The OCID for the compartment. This should always be the root compartment.
     */
    "compartmentId": string;
    /**
     * Information about the shapes in the capacity report.
     */
    "shapeAvailabilities": Array<model.CreateCapacityReportShapeAvailabilityDetails>;
}
export declare namespace CreateBdsCapacityReportDetails {
    function getJsonObj(obj: CreateBdsCapacityReportDetails): object;
    function getDeserializedJsonObj(obj: CreateBdsCapacityReportDetails): object;
}
