/**
 * Big Data Service API
 * REST API for Oracle Big Data Service. Use this API to build, deploy, and manage fully elastic Big Data Service clusters. Build on Hadoop, Spark and Data Science distributions, which can be fully integrated with existing enterprise data in Oracle Database and Oracle applications.

 * OpenAPI spec version: 20190531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The software update that is currently available for the cluster.
 */
export interface SoftwareUpdateSummary {
    /**
     * Unique identifier of a given software update
     */
    "softwareUpdateKey": string;
    /**
     * The version of the software update.
     */
    "softwareUpdateVersion": string;
    /**
     * The time when the software update was released.
     */
    "timeReleased": Date;
    /**
     * Type of current software update.
     */
    "softwareUpdateType": string;
    /**
     * The lifecycle state of the software update.
     */
    "lifecycleState": string;
}
export declare namespace SoftwareUpdateSummary {
    function getJsonObj(obj: SoftwareUpdateSummary): object;
    function getDeserializedJsonObj(obj: SoftwareUpdateSummary): object;
}
