/**
 * OCI Control Center Capacity Management API
 * OCI Control Center (OCC) Capacity Management enables you to manage capacity requests in realms where OCI Control Center Capacity Management is available. For more information, see [OCI Control Center](https://docs.oracle.com/iaas/Content/control-center/home.htm).
 * OpenAPI spec version: 20231107
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A summary model containing information about the details of a demand signal catalog resource.
 *
 */
export interface OccmDemandSignalCatalogResourceSummary {
    /**
     * The OCID of the demand signal catalog resource.
     *
     */
    "id": string;
    /**
     * The OCID of the tenancy from which the request to create the demand signal was made.
     *
     */
    "compartmentId": string;
    /**
     * The name of the OCI service in consideration for demand signal submission. For example: COMPUTE, NETWORK, GPU etc.
     *
     */
    "namespace": model.DemandSignalNamespace;
    /**
     * The name of the OCI resource that you want to request.
     *
     */
    "name": string;
    /**
     * The OCID of the customer tenancy for which this resource will be available for the customer to order against.
     *
     */
    "targetCompartmentId"?: string;
    /**
     * The name of region for which you want to request the OCI resource. This is an optional parameter.
     *
     */
    "region"?: string;
    /**
     * The name of the availability domain for which you want to request the OCI resource. This is an optional parameter.
     *
     */
    "availabilityDomain"?: string;
    "resourceProperties"?: model.OccmDemandSignalResourcePropertiesCollection;
    "resourcePropertyConstraints"?: model.OccmDemandSignalResourcePropertyConstraintsCollection;
    /**
     * The current lifecycles state of the demand signal catalog resource.
     *
     */
    "lifecycleState": string;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: {@code {\"bar-key\": \"value\"}}
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: {@code {\"foo-namespace\": {\"bar-key\": \"value\"}}}
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
     * System tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: {@code {\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}}
     *
     */
    "systemTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
     * The time when the demand signal catalog resource was created.
     *
     */
    "timeCreated": Date;
    /**
     * The time when the demand signal catalog resource was last updated.
     *
     */
    "timeUpdated": Date;
}
export declare namespace OccmDemandSignalCatalogResourceSummary {
    function getJsonObj(obj: OccmDemandSignalCatalogResourceSummary): object;
    function getDeserializedJsonObj(obj: OccmDemandSignalCatalogResourceSummary): object;
}
