/**
 * OCI Control Center Capacity Management API
 * OCI Control Center (OCC) Capacity Management enables you to manage capacity requests in realms where OCI Control Center Capacity Management is available. For more information, see [OCI Control Center](https://docs.oracle.com/iaas/Content/control-center/home.htm).
 * OpenAPI spec version: 20231107
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * A summary model for the demand signal catalog.
 *
 */
export interface OccmDemandSignalCatalogSummary {
    /**
     * compartment id from where demand signal catalog is created.
     *
     */
    "compartmentId": string;
    /**
     * The customer group OCID to which the availability catalog belongs.
     */
    "occCustomerGroupId": string;
    /**
     * The ocid of demand signal catalog.
     *
     */
    "id": string;
    /**
     * displayName of demand signal catalog.
     *
     */
    "displayName": string;
    /**
     * description of demand signal catalog.
     *
     */
    "description"?: string;
    /**
     * The current lifecycle state of the demand signal catalog.
     *
     */
    "lifecycleState": string;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: {@code {\"bar-key\": \"value\"}}
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: {@code {\"foo-namespace\": {\"bar-key\": \"value\"}}}
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
     * System tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: {@code {\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}}
     *
     */
    "systemTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
     * The time when the demand signal catalog was created.
     *
     */
    "timeCreated": Date;
    /**
     * The time when the demand signal catalog was last updated.
     *
     */
    "timeUpdated": Date;
}
export declare namespace OccmDemandSignalCatalogSummary {
    function getJsonObj(obj: OccmDemandSignalCatalogSummary): object;
    function getDeserializedJsonObj(obj: OccmDemandSignalCatalogSummary): object;
}
