/**
 * OCI Control Center Capacity Management API
 * OCI Control Center (OCC) Capacity Management enables you to manage capacity requests in realms where OCI Control Center Capacity Management is available. For more information, see [OCI Control Center](https://docs.oracle.com/iaas/Content/control-center/home.htm).
 * OpenAPI spec version: 20231107
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A summary model for the Occm demand signal resource properties.
 *
 */
export interface OccmDemandSignalResourcePropertiesSummary {
    /**
     * The name of demand signal resource's property.
     *
     */
    "propertyName": string;
    /**
     * Default value of demand signal resource's property.
     *
     */
    "propertyValue": string;
    /**
     * The minimum value of demand signal resource's property. This is an optional parameter.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "propertyMinValue"?: number;
    /**
     * The maximum value of demand signal resource's property. This is an optional parameter.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "propertyMaxValue"?: number;
    /**
     * Predefined options for demand signal resource's property. This is an optional parameter.
     *
     */
    "propertyOptions"?: Array<model.OccmDemandSignalResourcePropertyOptionSummary>;
    /**
     * Unit for demand signal resource's property.
     *
     */
    "propertyUnit"?: string;
    /**
     * This will indicate if demand signal resource's property is editable.
     *
     */
    "isEditable": boolean;
}
export declare namespace OccmDemandSignalResourcePropertiesSummary {
    function getJsonObj(obj: OccmDemandSignalResourcePropertiesSummary): object;
    function getDeserializedJsonObj(obj: OccmDemandSignalResourcePropertiesSummary): object;
}
