/**
 * OCI Control Center Capacity Management API
 * OCI Control Center (OCC) Capacity Management enables you to manage capacity requests in realms where OCI Control Center Capacity Management is available. For more information, see [OCI Control Center](https://docs.oracle.com/iaas/Content/control-center/home.htm).
 * OpenAPI spec version: 20231107
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * An internal model to update the demand signal state.
 *
 */
export interface UpdateInternalOccmDemandSignalDetails {
    /**
      * The subset of demand signal states available for operators for updating the demand signal.
  * <p>
  IN_PROGRESS -> Transitions the demand signal to IN_PROGRESS state.
  * REJECTED -> Transitions the demand signal to REJECTED state.
  * COMPLETED -> This will transition the demand signal to COMPLETED state.
  *
      */
    "lifecycleDetails"?: UpdateInternalOccmDemandSignalDetails.LifecycleDetails;
}
export declare namespace UpdateInternalOccmDemandSignalDetails {
    enum LifecycleDetails {
        InProgress = "IN_PROGRESS",
        Completed = "COMPLETED",
        Rejected = "REJECTED"
    }
    function getJsonObj(obj: UpdateInternalOccmDemandSignalDetails): object;
    function getDeserializedJsonObj(obj: UpdateInternalOccmDemandSignalDetails): object;
}
