/**
 * OCI Control Center Capacity Management API
 * OCI Control Center (OCC) Capacity Management enables you to manage capacity requests in realms where OCI Control Center Capacity Management is available. For more information, see [OCI Control Center](https://docs.oracle.com/iaas/Content/control-center/home.htm).
 * OpenAPI spec version: 20231107
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Details about different fields used to update the demand signal item.
 *
 */
export interface UpdateOccmDemandSignalItemDetails {
    /**
     * The region for which you want to request the resource for.
     *
     */
    "region"?: string;
    /**
     * The name of the availability domain for which you want to request the OCI resource.
     *
     */
    "availabilityDomain"?: string;
    /**
     * The OCID of the tenancy for which you want to request the OCI resource for.
     *
     */
    "targetCompartmentId"?: string;
    /**
     * The quantity of the resource that you want to demand from OCI.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "demandQuantity"?: number;
    /**
     * the date before which you would ideally like the OCI resource to be delivered to you.
     *
     */
    "timeNeededBefore"?: Date;
    /**
     * A map of various properties associated with the OCI resource. This parameter will act as a replace parameter i.e the existing resource properties will be overridden by this update.
     *
     */
    "resourceProperties"?: {
        [key: string]: string;
    };
    /**
      * This field will serve as notes section for you. You can use this section to convey a message to OCI regarding your resource request.
  * <p>
  NOTE: The previous value gets overwritten with the new one for this once updated.
  *
      */
    "notes"?: string;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: {@code {\"bar-key\": \"value\"}}
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: {@code {\"foo-namespace\": {\"bar-key\": \"value\"}}}
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace UpdateOccmDemandSignalItemDetails {
    function getJsonObj(obj: UpdateOccmDemandSignalItemDetails): object;
    function getDeserializedJsonObj(obj: UpdateOccmDemandSignalItemDetails): object;
}
