/**
 *
 *
 * OpenAPI spec version: 20231107
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/capacitymanagement/ListInternalOccmDemandSignalCatalogResources.ts.html |here} to see how to use ListInternalOccmDemandSignalCatalogResourcesRequest.
 */
export interface ListInternalOccmDemandSignalCatalogResourcesRequest extends common.BaseRequest {
    /**
     * The ocid of the compartment or tenancy in which resources are to be listed. This will also be used for authorization purposes.
     */
    "compartmentId": string;
    /**
     * The customer group ocid by which we would filter the list.
     */
    "occCustomerGroupId": string;
    /**
     * The ocid of demand signal catalog id.
     */
    "occmDemandSignalCatalogId": string;
    /**
     * A query parameter to filter the list of demand signal catalog resource based on the resource name.
     *
     */
    "name"?: string;
    /**
     * A query parameter to filter the list of demand signal catalog resources based on the namespace.
     *
     */
    "demandSignalNamespace"?: model.DemandSignalNamespace;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * A token representing the position at which to start retrieving results. This must come from {@code opc-next-page} header field of a previous response.
     */
    "page"?: string;
    /**
     * The client request ID for tracing. The only valid characters for request IDs are letters, numbers,
     * underscore, and dash.
     *
     */
    "opcRequestId"?: string;
    /**
     * The sort order to use, either 'ASC' or 'DESC'.
     */
    "sortOrder"?: model.SortOrder;
    /**
     * The field to sort the response of List Demand catalog resources API. Only one sort order may be provided. The default order for name is case sensitive alphabetical order.
     *
     */
    "sortBy"?: ListInternalOccmDemandSignalCatalogResourcesRequest.SortBy;
}
export declare namespace ListInternalOccmDemandSignalCatalogResourcesRequest {
    enum SortBy {
        Name = "name"
    }
}
