/**
 *
 *
 * OpenAPI spec version: 20231107
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/capacitymanagement/ListInternalOccmDemandSignals.ts.html |here} to see how to use ListInternalOccmDemandSignalsRequest.
 */
export interface ListInternalOccmDemandSignalsRequest extends common.BaseRequest {
    /**
     * The ocid of the compartment or tenancy in which resources are to be listed. This will also be used for authorization purposes.
     */
    "compartmentId": string;
    /**
     * The customer group ocid by which we would filter the list.
     */
    "occCustomerGroupId": string;
    /**
     * A query parameter to filter the list of demand signals based on it's OCID.
     *
     */
    "id"?: string;
    /**
     * A query parameter to filter the list of demand signals based on its state.
     *
     */
    "lifecycleDetails"?: string;
    /**
     * A filter to return only the resources that match the entire display name. The match is not case sensitive.
     */
    "displayName"?: string;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * A token representing the position at which to start retrieving results. This must come from {@code opc-next-page} header field of a previous response.
     */
    "page"?: string;
    /**
     * The client request ID for tracing. The only valid characters for request IDs are letters, numbers,
     * underscore, and dash.
     *
     */
    "opcRequestId"?: string;
    /**
     * The sort order to use, either 'ASC' or 'DESC'.
     */
    "sortOrder"?: model.SortOrder;
    /**
     * The field to sort the response of List Demand Signal API. Only one sort order may be provided. The default order for timeCreated is reverse chronological order (latest date at the top). The default order for displayName is case sensitive alphabetical order.
     *
     */
    "sortBy"?: ListInternalOccmDemandSignalsRequest.SortBy;
}
export declare namespace ListInternalOccmDemandSignalsRequest {
    enum SortBy {
        TimeCreated = "timeCreated",
        DisplayName = "displayName"
    }
}
