/**
 * Oracle Cloud Agent API
 * API for the Oracle Cloud Agent software running on compute instances. Oracle Cloud Agent
is a lightweight process that monitors and manages compute instances.

 * OpenAPI spec version: 20180530
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The contents of the command.
 */
export interface InstanceAgentCommandContent {
    /**
     * The source of the command.
     */
    "source": model.InstanceAgentCommandSourceViaObjectStorageTupleDetails | model.InstanceAgentCommandSourceViaObjectStorageUriDetails | model.InstanceAgentCommandSourceViaTextDetails;
    /**
     * The output destination for the command.
     */
    "output"?: model.InstanceAgentCommandOutputViaObjectStorageUriDetails | model.InstanceAgentCommandOutputViaObjectStorageTupleDetails | model.InstanceAgentCommandOutputViaTextDetails;
    /**
     * Command String is a fully formed command that runcommand executes.
     * Example: main.sh is stored in object storage and user provides the following command with parameters to execute
     * /bin/sh main.sh abc 10 foo.sh
     *
     */
    "commandString"?: string;
}
export declare namespace InstanceAgentCommandContent {
    function getJsonObj(obj: InstanceAgentCommandContent): object;
    function getDeserializedJsonObj(obj: InstanceAgentCommandContent): object;
}
