/**
 * Oracle Cloud Agent API
 * API for the Oracle Cloud Agent software running on compute instances. Oracle Cloud Agent
is a lightweight process that monitors and manages compute instances.

 * OpenAPI spec version: 20180530
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * An Oracle Cloud Agent plugin.
 */
export interface InstanceAgentPlugin {
    /**
     * The plugin name.
     */
    "name": string;
    /**
      * The plugin status.
  * <p>
  These are the available statuses:
  * * {@code RUNNING} - The plugin is running.
  * * {@code STOPPED} - The plugin is stopped.
  * * {@code NOT_SUPPORTED} - The plugin is not supported on this platform.
  * * {@code INVALID} - The plugin status is not recognizable by the service.
  * <p>
  To determine whether the plugin is enabled, use the
  * {@link #getInstance(GetInstanceRequest) getInstance} operation in the Core
  * Services API. To enable or disable the plugin, use the
  * {@link #updateInstance(UpdateInstanceRequest) updateInstance} operation
  * in the Core Services API.
  *
      */
    "status": InstanceAgentPlugin.Status;
    /**
     * The last updated time of the plugin, in UTC.
     */
    "timeLastUpdatedUtc": Date;
    /**
     * An optional message from the plugin.
     */
    "message"?: string;
}
export declare namespace InstanceAgentPlugin {
    enum Status {
        Running = "RUNNING",
        Stopped = "STOPPED",
        NotSupported = "NOT_SUPPORTED",
        Invalid = "INVALID",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: InstanceAgentPlugin): object;
    function getDeserializedJsonObj(obj: InstanceAgentPlugin): object;
}
