/**
 *
 *
 * OpenAPI spec version: 20180530
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/computeinstanceagent/ListInstanceagentAvailablePlugins.ts.html |here} to see how to use ListInstanceagentAvailablePluginsRequest.
 */
export interface ListInstanceagentAvailablePluginsRequest extends common.BaseRequest {
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
     */
    "compartmentId": string;
    /**
   * The image (OS) for the compute instance.
  * <p>
  If no match is found, all plugins are returned.
  * <p>
  Examples: {@code CentOS}, {@code Oracle Linux}, {@code Oracle Autonomous Linux}, {@code Canonical Ubuntu}, {@code Windows Server}
  *
   */
    "osName": string;
    /**
   * The OS version for the instance.
  * <p>
  If no match is found, all plugins are returned.
  * <p>
  Examples: {@code 7.9}, {@code 8} for CentOS and Oracle Linux. {@code 20.04}, {@code 20.04 Minimal} for Canonical Ubuntu.
  * {@code 2012 R2 Datacenter}, {@code 2019 Standard} for Windows Server.
  *
   */
    "osVersion": string;
    /**
     * Unique Oracle-assigned identifier for the request. If you need to contact Oracle about a particular request,
     * please provide the request ID.
     *
     */
    "opcRequestId"?: string;
    /**
     * For list pagination. The value of the {@code opc-next-page} response header from the previous \"List\"
     * call. For important details about how pagination works, see
     * [List Pagination](https://docs.oracle.com/iaas/Content/API/Concepts/usingapi.htm#nine).
     *
     */
    "page"?: string;
    /**
     * For list pagination. The maximum number of results per page, or items to return in a paginated
     * \"List\" call. For important details about how pagination works, see
     * [List Pagination](https://docs.oracle.com/iaas/Content/API/Concepts/usingapi.htm#nine).
     *
     */
    "limit"?: number;
    /**
     * The field to sort by. You can provide one sort order ({@code sortOrder}). Default order for
     * {@code TIMECREATED} is descending.
     * <p>
     **Note:** In general, some \"List\" operations (for example, {@code ListInstances}) let you
     * optionally filter by availability domain if the scope of the resource type is within a
     * single availability domain. If you call one of these \"List\" operations without specifying
     * an availability domain, the resources are grouped by availability domain, then sorted.
     *
     */
    "sortBy"?: ListInstanceagentAvailablePluginsRequest.SortBy;
    /**
     * The sort order to use, either ascending ({@code ASC}) or descending ({@code DESC}). The {@code DISPLAYNAME} sort order
     * is case sensitive.
     *
     */
    "sortOrder"?: ListInstanceagentAvailablePluginsRequest.SortOrder;
    /**
     * The plugin name.
     */
    "name"?: string;
}
export declare namespace ListInstanceagentAvailablePluginsRequest {
    enum SortBy {
        Timecreated = "TIMECREATED",
        Displayname = "DISPLAYNAME"
    }
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
}
