/**
 * Kubernetes Engine API
 * API for the Kubernetes Engine service (also known as the Container Engine for Kubernetes service). Use this API to build, deploy,
and manage cloud-native applications. For more information, see
[Overview of Kubernetes Engine](https://docs.oracle.com/iaas/Content/ContEng/Concepts/contengoverview.htm).

 * OpenAPI spec version: 20180222
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The property that define the status of the OIDC Discovery feature for a cluster.
 *
 */
export interface OpenIdConnectDiscovery {
    /**
     * Whether the cluster has OIDC Discovery enabled. Defaults to false. If set to true, the cluster will be assigned a public OIDC Discovery endpoint.
     *
     */
    "isOpenIdConnectDiscoveryEnabled"?: boolean;
}
export declare namespace OpenIdConnectDiscovery {
    function getJsonObj(obj: OpenIdConnectDiscovery): object;
    function getDeserializedJsonObj(obj: OpenIdConnectDiscovery): object;
}
