/**
 * Core Services API
 * Use the Core Services API to manage resources such as virtual cloud networks (VCNs),
compute instances, and block storage volumes. For more information, see the console
documentation for the [Networking](https://docs.oracle.com/iaas/Content/Network/Concepts/overview.htm),
[Compute](https://docs.oracle.com/iaas/Content/Compute/Concepts/computeoverview.htm), and
[Block Volume](https://docs.oracle.com/iaas/Content/Block/Concepts/overview.htm) services.
The required permissions are documented in the
[Details for the Core Services](https://docs.oracle.com/iaas/Content/Identity/Reference/corepolicyreference.htm) article.

 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The details for providing placement constraints using the compute bare metal host OCID.
 * This placement constraint is only applicable during the launch operation.
 *
 */
export interface ComputeBareMetalHostPlacementConstraintDetails extends model.PlacementConstraintDetails {
    /**
     * The OCID of the compute bare metal host. This is only available for dedicated capacity customers.
     */
    "computeBareMetalHostId": string;
    "type": string;
}
export declare namespace ComputeBareMetalHostPlacementConstraintDetails {
    function getJsonObj(obj: ComputeBareMetalHostPlacementConstraintDetails, isParentJsonObj?: boolean): object;
    const type = "COMPUTE_BARE_METAL_HOST";
    function getDeserializedJsonObj(obj: ComputeBareMetalHostPlacementConstraintDetails, isParentJsonObj?: boolean): object;
}
