/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](https://docs.oracle.com/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details to create an Oracle Autonomous Container Database by cloning from a backup of an existing Autonomous Container Database.
 *
 */
export interface CreateAutonomousContainerDatabaseFromBackupDetails extends model.CreateAutonomousContainerDatabaseBase {
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the source Autonomous Container Database Backup that you will clone to create a new Autonomous Container Database.
     */
    "autonomousContainerDatabaseBackupId": string;
    "source": string;
}
export declare namespace CreateAutonomousContainerDatabaseFromBackupDetails {
    function getJsonObj(obj: CreateAutonomousContainerDatabaseFromBackupDetails, isParentJsonObj?: boolean): object;
    const source = "BACKUP_FROM_ID";
    function getDeserializedJsonObj(obj: CreateAutonomousContainerDatabaseFromBackupDetails, isParentJsonObj?: boolean): object;
}
