/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](https://docs.oracle.com/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * It describes the various upgrade properties such as component, osversion, giversion for any VM DB system.
 *
 */
export interface DbSystemUpgradeSummary {
    /**
     * The component on which upgrade is applicable. OS (Operating System upgrade), GI (Grid Infrastructure upgrade) or OS_GI (both Operating System and Grid Infrastructure upgrade)
     */
    "component": DbSystemUpgradeSummary.Component;
    /**
     * The version of the OS for this upgrade eg. Oracle Linux Server release 7.9
     */
    "osVersion"?: string;
    /**
     * The version of the grid infrastructure for this upgrade. This is only applicable for ASM based DbSystems
     */
    "giVersion"?: string;
}
export declare namespace DbSystemUpgradeSummary {
    enum Component {
        Os = "OS",
        OsGi = "OS_GI",
        Gi = "GI",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: DbSystemUpgradeSummary): object;
    function getDeserializedJsonObj(obj: DbSystemUpgradeSummary): object;
}
