/**
 *
 *
 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/database/ListDbSystemStoragePerformances.ts.html |here} to see how to use ListDbSystemStoragePerformancesRequest.
 */
export interface ListDbSystemStoragePerformancesRequest extends common.BaseRequest {
    /**
     * The DB system storage management option. Used to list database versions available for that storage manager. Valid values are {@code ASM} and {@code LVM}.
     * * ASM specifies Oracle Automatic Storage Management
     * * LVM specifies logical volume manager, sometimes called logical disk manager.
     *
     */
    "storageManagement": string;
    /**
     * Optional. Filters the performance results by shape type.
     */
    "shapeType"?: string;
    /**
     * The database edition of quota (STANDARD_EDITION/ENTERPRISE_EDITION/ENTERPRISE_EDITION_HIGH_PERFORMANCE/ENTERPRISE_EDITION_EXTREME/ENTERPRISE_EDITION_DEVELOPER)
     */
    "databaseEdition"?: ListDbSystemStoragePerformancesRequest.DatabaseEdition;
    /**
     * Unique identifier for the request.
     *
     */
    "opcRequestId"?: string;
}
export declare namespace ListDbSystemStoragePerformancesRequest {
    enum DatabaseEdition {
        StandardEdition = "STANDARD_EDITION",
        EnterpriseEdition = "ENTERPRISE_EDITION",
        EnterpriseEditionHighPerformance = "ENTERPRISE_EDITION_HIGH_PERFORMANCE",
        EnterpriseEditionExtreme = "ENTERPRISE_EDITION_EXTREME",
        EnterpriseEditionDeveloper = "ENTERPRISE_EDITION_DEVELOPER"
    }
}
