/**
 *
 *
 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/database/ListSystemVersionMinorVersions.ts.html |here} to see how to use ListSystemVersionMinorVersionsRequest.
 */
export interface ListSystemVersionMinorVersionsRequest extends common.BaseRequest {
    /**
     * The System major version.
     */
    "majorVersion": string;
    /**
     * The compartment [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm).
     */
    "compartmentId": string;
    /**
     * Specifies gi version query parameter.
     */
    "giVersion": string;
    /**
     * The maximum number of items to return per page.
     */
    "limit"?: number;
    /**
     * The pagination token to continue listing from.
     */
    "page"?: string;
    /**
     * The sort order to use, either ascending ({@code ASC}) or descending ({@code DESC}).
     */
    "sortOrder"?: ListSystemVersionMinorVersionsRequest.SortOrder;
    /**
     * Unique identifier for the request.
     *
     */
    "opcRequestId"?: string;
    /**
     * If provided, filters the results for the given shape.
     */
    "shape"?: string;
    /**
     * If provided, filters the results for the specified resource Id.
     */
    "resourceId"?: string;
    /**
     * If provided, return highest versions from each major version family.
     */
    "isLatest"?: boolean;
}
export declare namespace ListSystemVersionMinorVersionsRequest {
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
}
