/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Details to change managed MySQL database management type.
 */
export interface ChangeMysqlDatabaseManagementTypeDetails {
    /**
     * The type of HeatWave management.
     */
    "managementType": string;
    /**
     * The type of operation to perform: update managementType, enable or disable database management.
     *
     */
    "operation"?: ChangeMysqlDatabaseManagementTypeDetails.Operation;
}
export declare namespace ChangeMysqlDatabaseManagementTypeDetails {
    enum Operation {
        EnableDbmgmt = "ENABLE_DBMGMT",
        UpdateDbmgmtType = "UPDATE_DBMGMT_TYPE",
        DisableDbmgmt = "DISABLE_DBMGMT"
    }
    function getJsonObj(obj: ChangeMysqlDatabaseManagementTypeDetails): object;
    function getDeserializedJsonObj(obj: ChangeMysqlDatabaseManagementTypeDetails): object;
}
