/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * the lifecycle state values for the Exadata infrastructure.
 */
export interface ExadataInfrastructureLifecycleStateValues {
    /**
     * The current lifecycle state of the Exadata infrastructure resource.
     */
    "state"?: ExadataInfrastructureLifecycleStateValues.State;
}
export declare namespace ExadataInfrastructureLifecycleStateValues {
    enum State {
        Creating = "CREATING",
        Active = "ACTIVE",
        Inactive = "INACTIVE",
        Updating = "UPDATING",
        Deleting = "DELETING",
        Deleted = "DELETED",
        Failed = "FAILED",
        Unknown = "UNKNOWN"
    }
    function getJsonObj(obj: ExadataInfrastructureLifecycleStateValues): object;
    function getDeserializedJsonObj(obj: ExadataInfrastructureLifecycleStateValues): object;
}
