/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Information pertaining to high availability of a MySQL server.
 */
export interface ManagedMySqlDatabaseHighAvailabilityMemberCollection {
    /**
     * The name of the group to which this server instance belongs.
     */
    "groupName"?: string;
    /**
     * Indicates if the replication group is running in single-primary mode.
     */
    "singlePrimaryMode"?: string;
    /**
     * The interval between successive values for auto-incremented columns for transactions that execute on this server instance. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "groupAutoIncrement"?: number;
    /**
     * The mode used for flow control.
     */
    "flowControl"?: string;
    /**
     * The state of this server as a group replication member.
     */
    "memberState"?: string;
    /**
     * The role of this server as a group replication member.
     */
    "memberRole"?: string;
    /**
     * The current view identifier for this group.
     */
    "viewId"?: string;
    /**
     * Number of transactions that were replicated within the cluster. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "transactionsInGtidExecuted"?: number;
    /**
     * A list of MySqlHighAvailabilityMember records.
     */
    "items": Array<model.ManagedMySqlDatabaseHighAvailabilityMemberSummary>;
    "statusSummary"?: model.MySqlHighAvailabilityStatusSummary;
}
export declare namespace ManagedMySqlDatabaseHighAvailabilityMemberCollection {
    function getJsonObj(obj: ManagedMySqlDatabaseHighAvailabilityMemberCollection): object;
    function getDeserializedJsonObj(obj: ManagedMySqlDatabaseHighAvailabilityMemberCollection): object;
}
