/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Information about a member of a MySQL server group replication for high availability.
 */
export interface ManagedMySqlDatabaseHighAvailabilityMemberSummary {
    /**
     * The host name of the group member which clients use to connect to it.
     */
    "memberHost": string;
    /**
     * The port number of the group member which clients to connect to it. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "memberPort": number;
    /**
     * The current state of the group member.
     */
    "memberState"?: string;
    /**
     * The current role of the group member in the group.
     */
    "memberRole"?: string;
    /**
     * The Universally Unique Identifier (UUID) of the member server.
     */
    "memberUuid": string;
}
export declare namespace ManagedMySqlDatabaseHighAvailabilityMemberSummary {
    function getJsonObj(obj: ManagedMySqlDatabaseHighAvailabilityMemberSummary): object;
    function getDeserializedJsonObj(obj: ManagedMySqlDatabaseHighAvailabilityMemberSummary): object;
}
