/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The collection of inbound replication records for a specific MySQL server.
 */
export interface ManagedMySqlDatabaseInboundReplicationCollection {
    /**
     * The number of sources this server is replicating from. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "inboundReplicationsCount"?: number;
    /**
     * The Universally Unique Identifier (UUID) value of this replica server.
     */
    "replicaUuid"?: string;
    /**
     * The server ID value of this replica. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "replicaServerId"?: number;
    /**
     * The number of applier threads for executing replication transactions in parallel. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "parallelWorkers"?: number;
    /**
     * For multi-threaded replicas, indicates if transactions are executed and committed on the replica in the same order as they appear in the relay log.
     */
    "preserveCommitOrder"?: string;
    /**
     * A list of ManagedMySqlDatabaseInboundReplicationSummary records.
     */
    "items": Array<model.ManagedMySqlDatabaseInboundReplicationSummary>;
}
export declare namespace ManagedMySqlDatabaseInboundReplicationCollection {
    function getJsonObj(obj: ManagedMySqlDatabaseInboundReplicationCollection): object;
    function getDeserializedJsonObj(obj: ManagedMySqlDatabaseInboundReplicationCollection): object;
}
