/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * An outbound replication record of a MySQL Server.
 */
export interface ManagedMySqlDatabaseOutboundReplicationSummary {
    /**
     * The host name of the replica server, as specified on the replica with the --report-host option. This can differ from the machine name as configured in the operating system.
     */
    "replicaHost"?: string;
    /**
     * The port on the replica server, as specified on the replica with the --report-port option. A zero in this column means that the replica port (--report-port) was not set. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "replicaPort"?: number;
    /**
     * The Universally Unique Identifier (UUID) value of the replica server.
     */
    "replicaUuid": string;
    /**
     * The server ID value of the replica. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "replicaServerId": number;
}
export declare namespace ManagedMySqlDatabaseOutboundReplicationSummary {
    function getJsonObj(obj: ManagedMySqlDatabaseOutboundReplicationSummary): object;
    function getDeserializedJsonObj(obj: ManagedMySqlDatabaseOutboundReplicationSummary): object;
}
