/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * If the replica is multi-threaded, error from worker threads. Otherwise error from the applier thread.
 */
export interface MySqlApplyErrorWorker {
    /**
     * The error number of the most recent error that caused the worker thread to stop. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "lastErrorNumber": number;
    /**
     * The error message of the most recent error that caused the worker thread to stop.
     */
    "lastErrorMessage": string;
    /**
     * The timestamp when the most recent worker error occurred.
     */
    "timeLastError": Date;
}
export declare namespace MySqlApplyErrorWorker {
    function getJsonObj(obj: MySqlApplyErrorWorker): object;
    function getDeserializedJsonObj(obj: MySqlApplyErrorWorker): object;
}
