/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The details of a given MySQL query, it consists of the query sample details, the explain plan and potential warnings.
 */
export interface MySqlQueryDetails {
    "querySampleDetails": model.MySqlQuerySampleDetails;
    "queryExplainPlan"?: model.MySqlQueryExplainPlan;
    /**
     * The errors, warnings and notes that could be raised by the execution of the query.
     */
    "queryMessages"?: Array<model.MySqlQueryMessage>;
}
export declare namespace MySqlQueryDetails {
    function getJsonObj(obj: MySqlQueryDetails): object;
    function getDeserializedJsonObj(obj: MySqlQueryDetails): object;
}
