/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The MySQL error, warning or note raised when a query is run, if any.
 */
export interface MySqlQueryMessage {
    /**
     * The level of severity of the MySQL message.
     */
    "level": model.MySqlMessageSeverity;
    /**
     * The MySQL code of the raised error, warning or note. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "code": number;
    /**
     * The MySQL message text of the raised error, warning or note.
     */
    "messageText": string;
}
export declare namespace MySqlQueryMessage {
    function getJsonObj(obj: MySqlQueryMessage): object;
    function getDeserializedJsonObj(obj: MySqlQueryMessage): object;
}
