/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The details of a query sample including the query text, execution time and other details.
 */
export interface MySqlQuerySampleDetails {
    /**
     * The query sample mapped by MySQL to a given normalized query.
     */
    "querySampleText": string;
    /**
     * The date and time the query sample was last seen.
     */
    "timeQuerySampleSeen": Date;
    /**
     * The total amount of time that has been spent executing the query sample. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "executionTime": number;
    /**
     * The thread id of the connection. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "threadId": number;
    /**
     * The user who ran the query sample.
     */
    "user": string;
    /**
     * The host from which the query sample was run.
     */
    "host": string;
    /**
     * The MySQL instance against which the query sample was run.
     */
    "mysqlInstance": string;
}
export declare namespace MySqlQuerySampleDetails {
    function getJsonObj(obj: MySqlQuerySampleDetails): object;
    function getDeserializedJsonObj(obj: MySqlQuerySampleDetails): object;
}
