/**
 * Data Safe API
 * APIs for using Oracle Data Safe.
 * OpenAPI spec version: 20181201
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * columnsInfo object has details of column group with schema details.
 */
export interface ColumnsInfo {
    /**
     * The schema name.
     */
    "schemaName": string;
    /**
     * The type of the database object that contains the sensitive column.
     */
    "objectType": ColumnsInfo.ObjectType;
    /**
     * The database object that contains the columns.
     */
    "objectName": string;
    /**
     * The application name.
     */
    "appName": string;
    /**
     * Group of columns in referential relation. Order needs to be maintained in the elements of the parent/child array listing.
     *
     */
    "columnGroup": Array<string>;
    /**
     * Sensitive type ocids of each column groups. Order needs to be maintained with the parent column group.
     * For the DB defined referential relations identified during SDM creation, we cannot add sensitive types.
     * Instead use the sensitiveColumn POST API to mark the columns sensitive.
     *
     */
    "sensitiveTypeIds"?: Array<string>;
}
export declare namespace ColumnsInfo {
    enum ObjectType {
        Table = "TABLE",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: ColumnsInfo): object;
    function getDeserializedJsonObj(obj: ColumnsInfo): object;
}
