/**
 * Data Safe API
 * APIs for using Oracle Data Safe.
 * OpenAPI spec version: 20181201
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A referential relation is a resource corresponding to a database columns.
 * It's a subresource of sensitive data model resource and is always associated with a sensitive data model.
 *
 */
export interface ReferentialRelationSummary {
    /**
     * The unique key that identifies the referential relation. It's numeric and unique within a sensitive data model.
     */
    "key": string;
    /**
     * The current state of the referential relation.
     */
    "lifecycleState": model.ReferentialRelationLifecycleState;
    /**
     * The OCID of the sensitive data model that contains the sensitive column.
     */
    "sensitiveDataModelId": string;
    /**
     * The type of referential relationship the sensitive column has with its parent. NONE indicates that the
     * sensitive column does not have a parent. DB_DEFINED indicates that the relationship is defined in the database
     * dictionary. APP_DEFINED indicates that the relationship is defined at the application level and not in the database dictionary.
     *
     */
    "relationType": ReferentialRelationSummary.RelationType;
    "parent": model.ColumnsInfo;
    "child": model.ColumnsInfo;
    /**
     * Determines if the columns present in the referential relation is present in the sensitive data model
     */
    "isSensitive"?: boolean;
}
export declare namespace ReferentialRelationSummary {
    enum RelationType {
        None = "NONE",
        AppDefined = "APP_DEFINED",
        DbDefined = "DB_DEFINED",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: ReferentialRelationSummary): object;
    function getDeserializedJsonObj(obj: ReferentialRelationSummary): object;
}
