/**
 * Data Science API
 * Use the Data Science API to organize your data science work, access data and computing resources, and build, train, deploy and manage models and model deployments. For more information, see [Data Science](https://docs.oracle.com/iaas/data-science/using/data-science.htm).

 * OpenAPI spec version: 20190101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The information about new MlApplicationInstance.
 */
export interface CreateMlApplicationInstanceDetails {
    /**
     * The name of MlApplicationInstance. System will generate displayName when not provided.
     */
    "displayName"?: string;
    /**
     * The OCID of ML Application. This resource is an instance of ML Application referenced by this OCID.
     */
    "mlApplicationId": string;
    /**
     * The OCID of ML Application Implementation selected as a certain solution for a given ML problem (ML Application)
     */
    "mlApplicationImplementationId": string;
    "authConfiguration"?: model.CreateIdcsAuthConfigurationDetails | model.CreateIdcsCustomServiceAuthConfigurationDetails | model.CreateIamAuthConfigurationCreateDetails;
    /**
     * Data that are used for provisioning of the given MlApplicationInstance. These are validated against configurationSchema defined in referenced MlApplicationImplementation.
     */
    "configuration"?: Array<model.ConfigurationProperty>;
    /**
     * Defines whether the MlApplicationInstance will be created in ACTIVE (true value) or INACTIVE (false value) lifecycle state.
     */
    "isEnabled"?: boolean;
    /**
     * The OCID of the compartment where the MlApplicationInstance is created.
     */
    "compartmentId": string;
    /**
     * Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. See [Resource Tags](https://docs.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).
     * Example: {@code {\"Department\": \"Finance\"}}
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace. See [Resource Tags](https://docs.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).
     * Example: {@code {\"Operations\": {\"CostCenter\": \"42\"}}}
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace CreateMlApplicationInstanceDetails {
    function getJsonObj(obj: CreateMlApplicationInstanceDetails): object;
    function getDeserializedJsonObj(obj: CreateMlApplicationInstanceDetails): object;
}
