/**
 *
 *
 * OpenAPI spec version: 20190101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/datascience/ListContainers.ts.html |here} to see how to use ListContainersRequest.
 */
export interface ListContainersRequest extends common.BaseRequest {
    /**
     * Unique Oracle assigned identifier for the request. If you need to contact Oracle about a particular request, then provide the request ID.
     *
     */
    "opcRequestId"?: string;
    /**
     * if true, this returns latest version of container.
     */
    "isLatest"?: boolean;
    /**
     * <b>Filter</b> results by its user-friendly name.
     */
    "displayName"?: string;
    /**
     * <b>Filter</b> results by the container name.
     */
    "containerName"?: string;
    /**
     * <b>Filter</b> results by the specified lifecycle state. Must be a valid
     *   state for the resource type.
     *
     */
    "lifecycleState"?: model.ContainerVersionLifecycleState;
    /**
     * <b>Filter</b> results by the target workload.
     */
    "targetWorkload"?: model.ContainerTargetWorkload;
    /**
     * <b>Filter</b> results by the usage.
     */
    "usageQueryParam"?: model.ContainerUsage;
    /**
     * <b>Filter</b> results by the container version tag.
     */
    "tagQueryParam"?: string;
    /**
   * For list pagination. The maximum number of results per page,
  * or items to return in a paginated \"List\" call.
  * 1 is the minimum, 100 is the maximum.
  * See [List Pagination](https://docs.oracle.com/iaas/Content/General/Concepts/usingapi.htm#nine).
  * <p>
  Example: {@code 50}
  *
   */
    "limit"?: number;
    /**
   * For list pagination. The value of the {@code opc-next-page} response
  * header from the previous \"List\" call.
  * <p>
  See [List Pagination](https://docs.oracle.com/iaas/Content/General/Concepts/usingapi.htm#nine).
  *
   */
    "page"?: string;
}
