/**
 * Dblm API
 * A description of the Dblm API
 * OpenAPI spec version: 20240102
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Image details containing the subscribed image, its status, version, owner and time of creation.
 */
export interface ImageDetails {
    /**
     * Image identifier.
     */
    "imageId"?: string;
    /**
     * Subscribed image.
     */
    "subscribedImage"?: string;
    /**
     * Name of the image version marked as current of the image.
     */
    "currentVersion"?: string;
    /**
     * Image status.
     */
    "imageStatus"?: ImageDetails.ImageStatus;
    /**
     * Release version of the image.
     */
    "imageVersion"?: string;
    /**
     * Owner of the image.
     */
    "imageOwner"?: string;
    /**
     * Name of the person who created the image.
     */
    "createdBy"?: string;
    /**
     * Date when the image was created.
     */
    "timeImageCreation"?: Date;
    /**
     * An image version name, that is up to date and has no recommendations.
     */
    "upToDateImageVersion"?: string;
}
export declare namespace ImageDetails {
    enum ImageStatus {
        Green = "GREEN",
        Yellow = "YELLOW",
        Red = "RED",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: ImageDetails): object;
    function getDeserializedJsonObj(obj: ImageDetails): object;
}
