/**
 * Dblm API
 * A description of the Dblm API
 * OpenAPI spec version: 20240102
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Summary of dblm registered and unregistered resources.
 */
export interface ResourceSummary {
    /**
     * The total number of resources. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "totalResourcesCount": number;
    /**
     * The total number of registered resources. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "registeredResourcesCount": number;
    /**
     * The total number of resources that are not registered. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "notRegisteredResourcesCount": number;
    /**
     * Total number of resources that have 1 or more vulnerabilities. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "vulnerableResourcesCount": number;
    /**
     * Total number of resources that have 0 vulnerabilities. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "cleanResourcesCount": number;
    /**
     * Total number of resources that contain an error. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "errorResourcesCount": number;
}
export declare namespace ResourceSummary {
    function getJsonObj(obj: ResourceSummary): object;
    function getDeserializedJsonObj(obj: ResourceSummary): object;
}
