"use strict";
/**
 * Full Stack Disaster Recovery API
 * Use the Full Stack Disaster Recovery (DR) API to manage disaster recovery for business applications.
Full Stack DR is an OCI disaster recovery orchestration and management service that provides comprehensive disaster
recovery capabilities for all layers of an application stack, including infrastructure, middleware, database,
and application.

 * OpenAPI spec version: 20220125
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutonomousContainerDatabaseSnapshotStandbyConnectionStringType = void 0;
/**
 * The type of connection strings used to connect to an Autonomous Container Database snapshot standby created during a DR Drill operation.
 * See https://docs.oracle.com/en/cloud/paas/autonomous-database/dedicated/adbcl/index.html for information about these service types.
 * - SNAPSHOT_SERVICE - Connect to the snapshot standby using new services that are active only in snapshot standby mode.
 * - PRIMARY_SERVICE - Connect to the snapshot standby database using the same services as the primary database.
 *
 **/
var AutonomousContainerDatabaseSnapshotStandbyConnectionStringType;
(function (AutonomousContainerDatabaseSnapshotStandbyConnectionStringType) {
    AutonomousContainerDatabaseSnapshotStandbyConnectionStringType["SnapshotService"] = "SNAPSHOT_SERVICE";
    AutonomousContainerDatabaseSnapshotStandbyConnectionStringType["PrimaryService"] = "PRIMARY_SERVICE";
    /**
     * This value is used if a service returns a value for this enum that is not recognized by this
     * version of the SDK.
     */
    AutonomousContainerDatabaseSnapshotStandbyConnectionStringType["UnknownValue"] = "UNKNOWN_VALUE";
})(AutonomousContainerDatabaseSnapshotStandbyConnectionStringType = exports.AutonomousContainerDatabaseSnapshotStandbyConnectionStringType || (exports.AutonomousContainerDatabaseSnapshotStandbyConnectionStringType = {}));
(function (AutonomousContainerDatabaseSnapshotStandbyConnectionStringType) {
    function getJsonObj(obj) {
        return obj;
    }
    AutonomousContainerDatabaseSnapshotStandbyConnectionStringType.getJsonObj = getJsonObj;
    function getDeserializedJsonObj(obj) {
        return obj;
    }
    AutonomousContainerDatabaseSnapshotStandbyConnectionStringType.getDeserializedJsonObj = getDeserializedJsonObj;
})(AutonomousContainerDatabaseSnapshotStandbyConnectionStringType = exports.AutonomousContainerDatabaseSnapshotStandbyConnectionStringType || (exports.AutonomousContainerDatabaseSnapshotStandbyConnectionStringType = {}));
//# sourceMappingURL=autonomous-container-database-snapshot-standby-connection-string-type.js.map