/**
 * Full Stack Disaster Recovery API
 * Use the Full Stack Disaster Recovery (DR) API to manage disaster recovery for business applications.
Full Stack DR is an OCI disaster recovery orchestration and management service that provides comprehensive disaster
recovery capabilities for all layers of an application stack, including infrastructure, middleware, database,
and application.

 * OpenAPI spec version: 20220125
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The details for creating a block volume attachment.
 *
 */
export interface CreateComputeInstanceNonMovableBlockVolumeAttachOperationDetails {
    /**
      * The OCID of the block volume.
  * <p>
  Example: {@code ocid1.volume.oc1..uniqueID}
  *
      */
    "blockVolumeId": string;
    /**
      * The OCID of the reference compute instance needed to obtain the volume attachment details.
  * This reference compute instance belongs to the peer DR protection group.
  * <p>
  Example: {@code ocid1.instance.oc1..uniqueID}
  *
      */
    "volumeAttachmentReferenceInstanceId"?: string;
}
export declare namespace CreateComputeInstanceNonMovableBlockVolumeAttachOperationDetails {
    function getJsonObj(obj: CreateComputeInstanceNonMovableBlockVolumeAttachOperationDetails): object;
    function getDeserializedJsonObj(obj: CreateComputeInstanceNonMovableBlockVolumeAttachOperationDetails): object;
}
