"use strict";
/**
 * Full Stack Disaster Recovery API
 * Use the Full Stack Disaster Recovery (DR) API to manage disaster recovery for business applications.
Full Stack DR is an OCI disaster recovery orchestration and management service that provides comprehensive disaster
recovery capabilities for all layers of an application stack, including infrastructure, middleware, database,
and application.

 * OpenAPI spec version: 20220125
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateDrProtectionGroupMemberOkeClusterDetails = void 0;
const model = __importStar(require("../model"));
var UpdateDrProtectionGroupMemberOkeClusterDetails;
(function (UpdateDrProtectionGroupMemberOkeClusterDetails) {
    function getJsonObj(obj, isParentJsonObj) {
        const jsonObj = Object.assign(Object.assign({}, (isParentJsonObj
            ? obj
            : model.UpdateDrProtectionGroupMemberDetails.getJsonObj(obj))), {
            "backupLocation": obj.backupLocation
                ? model.UpdateOkeBackupLocationDetails.getJsonObj(obj.backupLocation)
                : undefined,
            "backupConfig": obj.backupConfig
                ? model.UpdateOkeClusterBackupConfigDetails.getJsonObj(obj.backupConfig)
                : undefined,
            "loadBalancerMappings": obj.loadBalancerMappings
                ? obj.loadBalancerMappings.map(item => {
                    return model.UpdateOkeClusterLoadBalancerMappingDetails.getJsonObj(item);
                })
                : undefined,
            "networkLoadBalancerMappings": obj.networkLoadBalancerMappings
                ? obj.networkLoadBalancerMappings.map(item => {
                    return model.UpdateOkeClusterNetworkLoadBalancerMappingDetails.getJsonObj(item);
                })
                : undefined,
            "vaultMappings": obj.vaultMappings
                ? obj.vaultMappings.map(item => {
                    return model.UpdateOkeClusterVaultMappingDetails.getJsonObj(item);
                })
                : undefined,
            "managedNodePoolConfigs": obj.managedNodePoolConfigs
                ? obj.managedNodePoolConfigs.map(item => {
                    return model.UpdateOkeClusterManagedNodePoolConfigurationDetails.getJsonObj(item);
                })
                : undefined,
            "virtualNodePoolConfigs": obj.virtualNodePoolConfigs
                ? obj.virtualNodePoolConfigs.map(item => {
                    return model.UpdateOkeClusterVirtualNodePoolConfigurationDetails.getJsonObj(item);
                })
                : undefined
        });
        return jsonObj;
    }
    UpdateDrProtectionGroupMemberOkeClusterDetails.getJsonObj = getJsonObj;
    UpdateDrProtectionGroupMemberOkeClusterDetails.memberType = "OKE_CLUSTER";
    function getDeserializedJsonObj(obj, isParentJsonObj) {
        const jsonObj = Object.assign(Object.assign({}, (isParentJsonObj
            ? obj
            : model.UpdateDrProtectionGroupMemberDetails.getDeserializedJsonObj(obj))), {
            "backupLocation": obj.backupLocation
                ? model.UpdateOkeBackupLocationDetails.getDeserializedJsonObj(obj.backupLocation)
                : undefined,
            "backupConfig": obj.backupConfig
                ? model.UpdateOkeClusterBackupConfigDetails.getDeserializedJsonObj(obj.backupConfig)
                : undefined,
            "loadBalancerMappings": obj.loadBalancerMappings
                ? obj.loadBalancerMappings.map(item => {
                    return model.UpdateOkeClusterLoadBalancerMappingDetails.getDeserializedJsonObj(item);
                })
                : undefined,
            "networkLoadBalancerMappings": obj.networkLoadBalancerMappings
                ? obj.networkLoadBalancerMappings.map(item => {
                    return model.UpdateOkeClusterNetworkLoadBalancerMappingDetails.getDeserializedJsonObj(item);
                })
                : undefined,
            "vaultMappings": obj.vaultMappings
                ? obj.vaultMappings.map(item => {
                    return model.UpdateOkeClusterVaultMappingDetails.getDeserializedJsonObj(item);
                })
                : undefined,
            "managedNodePoolConfigs": obj.managedNodePoolConfigs
                ? obj.managedNodePoolConfigs.map(item => {
                    return model.UpdateOkeClusterManagedNodePoolConfigurationDetails.getDeserializedJsonObj(item);
                })
                : undefined,
            "virtualNodePoolConfigs": obj.virtualNodePoolConfigs
                ? obj.virtualNodePoolConfigs.map(item => {
                    return model.UpdateOkeClusterVirtualNodePoolConfigurationDetails.getDeserializedJsonObj(item);
                })
                : undefined
        });
        return jsonObj;
    }
    UpdateDrProtectionGroupMemberOkeClusterDetails.getDeserializedJsonObj = getDeserializedJsonObj;
})(UpdateDrProtectionGroupMemberOkeClusterDetails = exports.UpdateDrProtectionGroupMemberOkeClusterDetails || (exports.UpdateDrProtectionGroupMemberOkeClusterDetails = {}));
//# sourceMappingURL=update-dr-protection-group-member-oke-cluster-details.js.map