/**
 * Full Stack Disaster Recovery API
 * Use the Full Stack Disaster Recovery (DR) API to manage disaster recovery for business applications.
Full Stack DR is an OCI disaster recovery orchestration and management service that provides comprehensive disaster
recovery capabilities for all layers of an application stack, including infrastructure, middleware, database,
and application.

 * OpenAPI spec version: 20220125
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Update source-to-destination mapping for a load balancer.
 */
export interface UpdateOkeClusterLoadBalancerMappingDetails {
    /**
     * The OCID of the source Load Balancer .
     *
     *  Example: {@code ocid1.loadbalancer.oc1..uniqueID}
     *
     */
    "sourceLoadBalancerId": string;
    /**
      * The OCID of the destination Load Balancer.
  * <p>
  Example: {@code ocid1.loadbalancer.oc1..uniqueID}
  *
      */
    "destinationLoadBalancerId": string;
}
export declare namespace UpdateOkeClusterLoadBalancerMappingDetails {
    function getJsonObj(obj: UpdateOkeClusterLoadBalancerMappingDetails): object;
    function getDeserializedJsonObj(obj: UpdateOkeClusterLoadBalancerMappingDetails): object;
}
