/**
 * Globally Distributed Database
 * Use the Globally Distributed Database service APIs to create and manage the Globally distributed databases.
 * OpenAPI spec version: 20250101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as serviceRequests from "./request";
import * as serviceResponses from "./response";
import * as models from "./model";
import { DistributedDbServiceClient } from "./client";
export declare class DistributedDbServiceWaiter {
    private client;
    private readonly config?;
    constructor(client: DistributedDbServiceClient, config?: Partial<import("oci-common/lib/waiter").WaiterConfigurationDetails> | undefined);
    /**
     * Waits forDistributedDatabase till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetDistributedDatabaseResponse | null (null in case of 404 response)
     */
    forDistributedDatabase(request: serviceRequests.GetDistributedDatabaseRequest, ...targetStates: models.DistributedDatabase.LifecycleState[]): Promise<serviceResponses.GetDistributedDatabaseResponse | null>;
}
