/**
 * Globally Distributed Database
 * Use the Globally Distributed Database service APIs to create and manage the Globally distributed databases.
 * OpenAPI spec version: 20250101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Globally distributed autonomous database catalog based on Dedicated infrastructure.
 */
export interface CreateDistributedAutonomousDatabaseCatalogWithDedicatedInfraDetails extends model.CreateDistributedAutonomousDatabaseCatalogDetails {
    /**
     * Admin password for catalog database.
     */
    "adminPassword": string;
    /**
     * The compute count for the catalog database. It has to be in multiples of 2. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "computeCount": number;
    /**
     * The data disk group size to be allocated in GBs for the catalog database. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "dataStorageSizeInGbs": number;
    /**
     * Determines the auto-scaling mode for the catalog database.
     */
    "isAutoScalingEnabled": boolean;
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the cloud Autonomous VM Cluster.
     */
    "cloudAutonomousVmClusterId": string;
    /**
     * The collection of [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the peer cloud Autonomous VM Clusters.
     */
    "peerCloudAutonomousVmClusterIds"?: Array<string>;
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Oracle Cloud Infrastructure [vault](https://docs.oracle.com/iaas/Content/KeyManagement/Concepts/keyoverview.htm#concepts). This parameter and {@code kmsKeyId} are required for Customer Managed Keys.
     */
    "vaultId"?: string;
    /**
     * The OCID of the key container that is used as the master encryption key in database transparent data encryption (TDE) operations.
     */
    "kmsKeyId"?: string;
    /**
     * The OCID of the key container version that is used in database transparent data encryption (TDE) operations KMS Key can have multiple key versions.
     *
     */
    "kmsKeyVersionId"?: string;
    "source": string;
}
export declare namespace CreateDistributedAutonomousDatabaseCatalogWithDedicatedInfraDetails {
    function getJsonObj(obj: CreateDistributedAutonomousDatabaseCatalogWithDedicatedInfraDetails, isParentJsonObj?: boolean): object;
    const source = "ADB_D";
    function getDeserializedJsonObj(obj: CreateDistributedAutonomousDatabaseCatalogWithDedicatedInfraDetails, isParentJsonObj?: boolean): object;
}
