/**
 *
 *
 * OpenAPI spec version: 20250101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/distributeddatabase/ListDistributedAutonomousDatabases.ts.html |here} to see how to use ListDistributedAutonomousDatabasesRequest.
 */
export interface ListDistributedAutonomousDatabasesRequest extends common.BaseRequest {
    /**
     * The ID of the compartment in which to list resources.
     */
    "compartmentId": string;
    /**
     * A filter to return only resources their lifecycleState matches the given lifecycleState.
     */
    "lifecycleState"?: string;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * A token representing the position at which to start retrieving results. This must come from the {@code opc-next-page} header field of a previous response.
     */
    "page"?: string;
    /**
     * The sort order to use, either 'ASC' or 'DESC'.
     */
    "sortOrder"?: model.SortOrder;
    /**
     * The field to sort by. Only one sort order may be provided. Default order for timeCreated is descending. Default order for displayName is ascending.
     *
     */
    "sortBy"?: ListDistributedAutonomousDatabasesRequest.SortBy;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
    /**
     * A filter to return only Globally distributed autonomous databases that match the entire name given. The match is not case sensitive.
     */
    "displayName"?: string;
    /**
     * A filter to return only resources their dbDeploymentType matches the given dbDeploymentType.
     */
    "dbDeploymentType"?: string;
    /**
     * Comma separated names of argument corresponding to which metadata need to be retrived.
     *
     */
    "metadata"?: string;
}
export declare namespace ListDistributedAutonomousDatabasesRequest {
    enum SortBy {
        TimeCreated = "timeCreated",
        TimeUpdated = "timeUpdated"
    }
}
