/**
 * File Storage API
 * Use the File Storage service API to manage file systems, mount targets, and snapshots.
For more information, see [Overview of File Storage](https://docs.oracle.com/iaas/Content/File/Concepts/filestorageoverview.htm).

 * OpenAPI spec version: 20171215
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Details for updating a quota rule in the file system.
 */
export interface UpdateQuotaRuleDetails {
    /**
     * A user-friendly name that the quota rule will be renamed to. It does not have to be unique.
     * Avoid entering confidential information.
     * Example: {@code UserXYZ's quota}
     *
     */
    "displayName"?: string;
    /**
     * An updated value of the quota rule in gigabytes.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "quotaLimitInGigabytes"?: number;
}
export declare namespace UpdateQuotaRuleDetails {
    function getJsonObj(obj: UpdateQuotaRuleDetails): object;
    function getDeserializedJsonObj(obj: UpdateQuotaRuleDetails): object;
}
