/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Catalog source template config.
 *
 */
export interface CatalogSourceTemplateConfig extends model.CatalogSourcePayload {
    /**
     * The Base64 encoded template. This payload will trigger CreateTemplate API, where the parameter will be passed.
     *
     */
    "zipFileBase64Encoded"?: string;
    /**
     * Template Description
     *
     */
    "description"?: string;
    /**
     * Template Long Description
     *
     */
    "longDescription"?: string;
    /**
     * Template Display Name
     *
     */
    "templateDisplayName"?: string;
    "configSourceType": string;
}
export declare namespace CatalogSourceTemplateConfig {
    function getJsonObj(obj: CatalogSourceTemplateConfig, isParentJsonObj?: boolean): object;
    const configSourceType = "STACK_TEMPLATE_CATALOG_SOURCE";
    function getDeserializedJsonObj(obj: CatalogSourceTemplateConfig, isParentJsonObj?: boolean): object;
}
