/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details of the Policy associated
 */
export interface ComplianceDetailPolicy {
    /**
     * Compliance Policy Id
     */
    "compliancePolicyId": string;
    /**
     * Compliane Policy DisplayName
     */
    "compliancePolicyDisplayName"?: string;
    /**
     * Compliane Policy Rule Id
     */
    "compliancePolicyRuleId"?: string;
    /**
     * Product Name
     */
    "compliancePolicyRuleDisplayName"?: string;
    /**
     * Grace period in days,weeks,months or years the exemption is applicable for the rule.
     */
    "gracePeriod"?: string;
    "patchSelection"?: model.PatchLevelSelectionDetails | model.PatchReleaseDateSelectionDetails | model.PatchNameSelectionDetails;
}
export declare namespace ComplianceDetailPolicy {
    function getJsonObj(obj: ComplianceDetailPolicy): object;
    function getDeserializedJsonObj(obj: ComplianceDetailPolicy): object;
}
