/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A task associated with the Job.
 */
export interface ExecutionSummary {
    /**
     * Unique Id associated with the task execution.
     */
    "id": string;
    /**
     * The OCID of taskRecord.
     */
    "taskRecordId"?: string;
    /**
     * Name of the Step.
     */
    "stepName"?: string;
    /**
     * Unique process-reference identifier returned by the execution client.
     * In some cases, this can be a runcommand OCID.
     *
     */
    "processReferenceId"?: string;
    /**
     * The sequence of the task.
     */
    "sequence"?: string;
    /**
     * Status of the Task.
     */
    "status": model.JobStatus;
    /**
     * Target associated with the execution.
     */
    "targetId"?: string;
    /**
     * The time the task started. An RFC3339 formatted datetime string.
     */
    "timeStarted"?: Date;
    /**
     * The time the task ended. An RFC3339 formatted datetime string.
     */
    "timeEnded"?: Date;
    /**
     * Is this a rollback task?
     */
    "isRollbackTask"?: boolean;
    /**
     * Description of the Execution status.
     * If there are any errors, this can also include a short error message.
     *
     */
    "description"?: string;
    /**
     * Resource Identifier associated with the Work Request.
     */
    "resourceId"?: string;
    /**
     * An attribute which tells if further retries are allowed for the task on failure.
     */
    "isRetryExceeded"?: boolean;
    /**
     * System tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: {@code {\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}}
     *
     */
    "systemTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace ExecutionSummary {
    function getJsonObj(obj: ExecutionSummary): object;
    function getDeserializedJsonObj(obj: ExecutionSummary): object;
}
