/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The group of the runbook.
 *
 */
export interface Group {
    /**
     * The type of the group.
     * PARALLEL_TASK_GROUP : Helps to execute tasks parallelly inside a resource.
     * PARALLEL_RESOURCE_GROUP : Executes tasks across resources parallelly.
     * ROLLING_RESOURCE_GROUP : Executes tasks across resources in a rolling order.
     *
     */
    "type": Group.Type;
    /**
     * The name of the group.
     */
    "name": string;
    "properties"?: model.ComponentProperties;
}
export declare namespace Group {
    enum Type {
        ParallelTaskGroup = "PARALLEL_TASK_GROUP",
        ParallelResourceGroup = "PARALLEL_RESOURCE_GROUP",
        RollingResourceGroup = "ROLLING_RESOURCE_GROUP",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: Group): object;
    function getDeserializedJsonObj(obj: Group): object;
}
