/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Information about an inventory target.
 *
 */
export interface InventoryRecord {
    /**
     * The OCID of the Inventory target.
     */
    "targetId": string;
    /**
     * Name of the target
     */
    "targetName": string;
    /**
     * Version of the product on the target
     */
    "version": string;
    /**
     * OCID of the resource associated with the target
     */
    "targetResourceId": string;
    /**
     * Name of the resource associated with the target
     */
    "targetResourceName"?: string;
    /**
     * OCID of the compartment to which the resource belongs to.
     */
    "compartmentId": string;
    /**
     * OCID of the product installed at the target path
     */
    "targetProductId"?: string;
    /**
     * Name of the product installed at the target path
     */
    "targetProductName": string;
    /**
     * OS installed on the resource associated with the target
     */
    "osType": string;
    /**
     * Architecture of the resource associated with the target
     */
    "architecture": string;
    /**
     * List of target properties
     */
    "properties": Array<model.InventoryRecordProperty>;
    /**
     * List of target components
     */
    "components": Array<model.InventoryRecordComponent>;
    /**
     * List of details on the patches currently installed on the target
     */
    "installedPatches": Array<model.InventoryRecordPatchDetails>;
    /**
     * The time this resource was created. An RFC3339 formatted datetime string.
     */
    "timeCreated"?: Date;
    /**
     * The time this resource was last updated. An RFC3339 formatted datetime string.
     */
    "timeUpdated"?: Date;
    /**
     * The current state of the Inventory target.
     */
    "lifecycleState"?: InventoryRecord.LifecycleState;
}
export declare namespace InventoryRecord {
    enum LifecycleState {
        Active = "ACTIVE",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: InventoryRecord): object;
    function getDeserializedJsonObj(obj: InventoryRecord): object;
}
