/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Notification information to get notified when the fleet status changes.
 */
export interface NotificationPreference {
    /**
     * Topic Id where the notifications will be directed.
     * A topic is a communication channel for sending messages on chosen events to subscriptions.
     *
     */
    "topicId": string;
    /**
     * Compartment ID the topic belongs to.
     */
    "compartmentId": string;
    "preferences"?: model.Preferences;
}
export declare namespace NotificationPreference {
    function getJsonObj(obj: NotificationPreference): object;
    function getDeserializedJsonObj(obj: NotificationPreference): object;
}
