/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details about Object Storage Bucket source.
 * Restricted to the region this is called.
 *
 */
export interface ObjectStorageBucketContentDetails extends model.ContentDetails {
    /**
     * Namespace.
     */
    "namespaceName": string;
    /**
     * Bucket Name.
     */
    "bucketName": string;
    /**
     * Object Name.
     */
    "objectName": string;
    /**
     * md5 checksum of the artifact.
     */
    "checksum": string;
    "sourceType": string;
}
export declare namespace ObjectStorageBucketContentDetails {
    function getJsonObj(obj: ObjectStorageBucketContentDetails, isParentJsonObj?: boolean): object;
    const sourceType = "OBJECT_STORAGE_BUCKET";
    function getDeserializedJsonObj(obj: ObjectStorageBucketContentDetails, isParentJsonObj?: boolean): object;
}
