/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Days since patch release date details.
 * If you set the policy rule by selecting this option and entering the number of days since release, Fleet Application Management calculates the number of days passed after the release date and reports the product as noncompliant if the days exceed the number provided in Days since release
 *
 */
export interface PatchReleaseDateSelectionDetails extends model.PatchSelectionDetails {
    /**
     * Days passed since patch release. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "daysSinceRelease": number;
    "selectionType": string;
}
export declare namespace PatchReleaseDateSelectionDetails {
    function getJsonObj(obj: PatchReleaseDateSelectionDetails, isParentJsonObj?: boolean): object;
    const selectionType = "PATCH_RELEASE_DATE";
    function getDeserializedJsonObj(obj: PatchReleaseDateSelectionDetails, isParentJsonObj?: boolean): object;
}
