/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Preferences to send notifications on the fleet activities.
 */
export interface Preferences {
    "upcomingSchedule"?: model.UpcomingSchedule;
    /**
     * Enables or disables notification on Job Failures.
     */
    "onJobFailure"?: boolean;
    /**
     * Enables or disables notification on Environment Fleet Topology Modification.
     */
    "onTopologyModification"?: boolean;
    /**
     * Enables or disables notification when a task is paused.
     */
    "onTaskPause"?: boolean;
    /**
     * Enables or disables notification on task failure.
     */
    "onTaskFailure"?: boolean;
    /**
     * Enables or disables notification on task success.
     */
    "onTaskSuccess"?: boolean;
    /**
     * Enables or disables notification when fleet resource becomes non compliant.
     */
    "onResourceNonCompliance"?: boolean;
    /**
     * Enables or disables notification when a newer version of runbook associated with a fleet is available
     */
    "onRunbookNewerVersion"?: boolean;
}
export declare namespace Preferences {
    function getJsonObj(obj: Preferences): object;
    function getDeserializedJsonObj(obj: Preferences): object;
}
