/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Consider Product stack as product.To be provided if the product stack should be considered as a Product also.
 * Allows compliance reporting and patching against the product stack target.
 *
 */
export interface ProductStackAsProductSubCategoryDetails extends model.ProductStackSubCategoryDetails {
    /**
     * Versions associated with the PRODUCT .
     *
     */
    "versions": Array<string>;
    /**
     * OCID for the Credential name to be associated with the Product Stack.
     * These are useful for target discovery or lifecycle management activities, for example, Oracle WebLogic admin credentials for Oracle WebLogic Application server.
     *
     */
    "credentials"?: Array<model.ConfigAssociationDetails>;
    /**
     * Various components of the Product.
     * For example:The administration server or node manager can be the components of the Oracle WebLogic Application server.
     * Forms server or concurrent manager can be the components of the Oracle E-Business Suite.
     *
     */
    "components"?: Array<string>;
    /**
     * Patch Types associated with this Product Stack which will be considered as Product.
     *
     */
    "patchTypes"?: Array<model.ConfigAssociationDetails>;
    "subCategory": string;
}
export declare namespace ProductStackAsProductSubCategoryDetails {
    function getJsonObj(obj: ProductStackAsProductSubCategoryDetails, isParentJsonObj?: boolean): object;
    const subCategory = "PRODUCT_STACK_AS_PRODUCT";
    function getDeserializedJsonObj(obj: ProductStackAsProductSubCategoryDetails, isParentJsonObj?: boolean): object;
}
