/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Rule Selection Criteria for DYNAMIC resource selection for a GENERIC fleet.
 * Rules define what resources are members of this fleet. All resources that meet the criteria are added automatically.
 *
 */
export interface SelectionCriteria {
    /**
     * Match condition for the rule selection.
     * Include resources that match all rules or any of the rules.
     *
     */
    "matchCondition": SelectionCriteria.MatchCondition;
    /**
     * Rules.
     */
    "rules": Array<model.Rule>;
}
export declare namespace SelectionCriteria {
    enum MatchCondition {
        MatchAll = "MATCH_ALL",
        Any = "ANY",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: SelectionCriteria): object;
    function getDeserializedJsonObj(obj: SelectionCriteria): object;
}
