/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details for a user action to be performed on a step.
 */
export interface StepBasedUserActionDetails extends model.UserActionDetails {
    /**
     * Unique identifier for the action group.
     */
    "actionGroupId": string;
    /**
     * Resource OCID
     *
     */
    "resourceId": string;
    /**
     * Target associated with the execution.
     */
    "targetId"?: string;
    /**
     * Name of the step on which user action needs to be performed.
     */
    "stepName": string;
    "level": string;
}
export declare namespace StepBasedUserActionDetails {
    function getJsonObj(obj: StepBasedUserActionDetails, isParentJsonObj?: boolean): object;
    const level = "STEP_NAME";
    function getDeserializedJsonObj(obj: StepBasedUserActionDetails, isParentJsonObj?: boolean): object;
}
