/**
 * Fleet Application Management Service API
 * Fleet Application Management provides a centralized platform to help you automate resource management tasks, validate patch compliance, and enhance operational efficiency across an enterprise.

 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details for Terraform execution.
 */
export interface TerraformBasedExecutionDetails extends model.ExecutionDetails {
    /**
     * Catalog Id having terraform package.
     */
    "catalogId": string;
    /**
     * Catalog Id having config file.
     */
    "configFile"?: string;
    /**
     * OCID of the compartment to which the resource belongs to.
     */
    "targetCompartmentId": string;
    /**
     * Is read output variable enabled
     */
    "isReadOutputVariableEnabled"?: boolean;
    "executionType": string;
}
export declare namespace TerraformBasedExecutionDetails {
    function getJsonObj(obj: TerraformBasedExecutionDetails, isParentJsonObj?: boolean): object;
    const executionType = "TERRAFORM";
    function getDeserializedJsonObj(obj: TerraformBasedExecutionDetails, isParentJsonObj?: boolean): object;
}
