/**
 *
 *
 * OpenAPI spec version: 20250228
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/fleetappsmanagement/ListSchedulerJobs.ts.html |here} to see how to use ListSchedulerJobsRequest.
 */
export interface ListSchedulerJobsRequest extends common.BaseRequest {
    /**
     * The ID of the compartment in which to list resources.
     * Empty only if the resource OCID query param is not specified.
     *
     */
    "compartmentId"?: string;
    /**
     * If set to true, resources will be returned for not only the provided compartment, but all compartments which
     * descend from it. Which resources are returned and their field contents depends on the value of accessLevel.
     *
     */
    "compartmentIdInSubtree"?: boolean;
    /**
     * A filter to return only resources whose lifecycleState matches the given lifecycleState.
     */
    "lifecycleState"?: string;
    /**
     * unique Fleet identifier
     */
    "fleetId"?: string;
    /**
     * Scheduled Time
     */
    "timeScheduledGreaterThanOrEqualTo"?: Date;
    /**
     * Scheduled Time
     */
    "timeScheduledLessThan"?: Date;
    /**
     * Fetch next remediation Job
     */
    "isRemediationJobNeeded"?: boolean;
    /**
     * A filter to return only resources their subState matches the given subState.
     */
    "substate"?: string;
    /**
     * A filter to return only resources that match the entire display name given.
     */
    "displayName"?: string;
    /**
     * Unique identifier or OCID for listing a single Schedule Job by id.
     * Either compartmentId or id must be provided.
     *
     */
    "id"?: string;
    /**
     * SchedulerDefinition identifier
     */
    "schedulerDefintionId"?: string;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * A token representing the position at which to start retrieving results. This must come from the {@code opc-next-page} header field of a previous response.
     */
    "page"?: string;
    /**
     * The sort order to use, either 'ASC' or 'DESC'.
     */
    "sortOrder"?: model.SortOrder;
    /**
     * The field to sort by. Only one sort order may be provided. Default order for timeCreated and timeScheduled is descending. Default order for displayName is ascending.
     *
     */
    "sortBy"?: ListSchedulerJobsRequest.SortBy;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
export declare namespace ListSchedulerJobsRequest {
    enum SortBy {
        TimeCreated = "timeCreated",
        TimeScheduled = "timeScheduled",
        DisplayName = "displayName"
    }
}
