/**
 * Exadata Fleet Update service API
 * Use the Exadata Fleet Update service to patch large collections of components directly,
as a single entity, orchestrating the maintenance actions to update all chosen components in the stack in a single cycle.

 * OpenAPI spec version: 20220528
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The Database service Database Software Image resource is required as goal version for the Exadata Fleet Update Maintenance Cycle
 * when IMAGE_ID type is selected.
 * Specify a Database Software Image of type DATABASE_IMAGE for a DB Collection.
 * Specify a Database Software Image of type GRID_IMAGE for a GI Collection.
 *
 */
export interface ImageIdFsuTargetDetails extends model.FsuGoalVersionDetails {
    /**
     * Target database software image OCID.
     *
     */
    "softwareImageId": string;
    "type": string;
}
export declare namespace ImageIdFsuTargetDetails {
    function getJsonObj(obj: ImageIdFsuTargetDetails, isParentJsonObj?: boolean): object;
    const type = "IMAGE_ID";
    function getDeserializedJsonObj(obj: ImageIdFsuTargetDetails, isParentJsonObj?: boolean): object;
}
