/**
 * Generative AI Agents Management API
 * OCI Generative AI Agents is a fully managed service that combines the power of large language models (LLMs) with an intelligent retrieval system to create contextually relevant answers by searching your knowledge base, making your AI applications smart and efficient.

OCI Generative AI Agents supports several ways to onboard your data and then allows you and your customers to interact with your data using a chat interface or API.

Use the Generative AI Agents API to create and manage agents, knowledge bases, data sources, endpoints, data ingestion jobs, and work requests.

For creating and managing client chat sessions see the {@link #eNGenerative-ai-agents-clientLatest(ENGenerative-ai-agents-clientLatestRequest) eNGenerative-ai-agents-clientLatest}.

To learn more about the service, see the [Generative AI Agents documentation](https://docs.oracle.com/iaas/Content/generative-ai-agents/home.htm).

 * OpenAPI spec version: 20240531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The config of object storage.
 *
 */
export interface ObjectStoragePrefixOutputLocation extends model.OutputLocation {
    /**
     * The namespace of the object storage.
     */
    "namespaceName": string;
    /**
     * The name of the bucket.
     */
    "bucketName": string;
    /**
     * The prefix of the object storage.
     */
    "prefix"?: string;
    "outputLocationType": string;
}
export declare namespace ObjectStoragePrefixOutputLocation {
    function getJsonObj(obj: ObjectStoragePrefixOutputLocation, isParentJsonObj?: boolean): object;
    const outputLocationType = "OBJECT_STORAGE_PREFIX";
    function getDeserializedJsonObj(obj: ObjectStoragePrefixOutputLocation, isParentJsonObj?: boolean): object;
}
