/**
 * GoldenGate API
 * Use the Oracle Cloud Infrastructure GoldenGate APIs to perform data replication operations.

 * OpenAPI spec version: 20200407
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Summary of the Amazon Redshift Connection.
 *
 */
export interface AmazonRedshiftConnectionSummary extends model.ConnectionSummary {
    /**
     * The Amazon Redshift technology type.
     */
    "technologyType": string;
    /**
     * Connection URL.
     * e.g.: 'jdbc:redshift://aws-redshift-instance.aaaaaaaaaaaa.us-east-2.redshift.amazonaws.com:5439/mydb'
     *
     */
    "connectionUrl": string;
    /**
     * The username Oracle GoldenGate uses to connect the associated system of the given technology.
     * This username must already exist and be available by the system/application to be connected to
     * and must conform to the case sensitivty requirments defined in it.
     *
     */
    "username": string;
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Secret where the password is stored.
     * The password Oracle GoldenGate uses to connect the associated system of the given technology.
     * It must conform to the specific security requirements including length, case sensitivity, and so on.
     * If secretId is used plaintext field must not be provided.
     * Note: When provided, 'password' field must not be provided.
     *
     */
    "passwordSecretId"?: string;
    "connectionType": string;
}
export declare namespace AmazonRedshiftConnectionSummary {
    function getJsonObj(obj: AmazonRedshiftConnectionSummary, isParentJsonObj?: boolean): object;
    const connectionType = "AMAZON_REDSHIFT";
    function getDeserializedJsonObj(obj: AmazonRedshiftConnectionSummary, isParentJsonObj?: boolean): object;
}
