/**
 * GoldenGate API
 * Use the Oracle Cloud Infrastructure GoldenGate APIs to perform data replication operations.

 * OpenAPI spec version: 20200407
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The information about a new Google PubSub Connection.
 *
 */
export interface CreateGooglePubSubConnectionDetails extends model.CreateConnectionDetails {
    /**
     * The Google PubSub technology type.
     */
    "technologyType": string;
    /**
     * The base64 encoded content of the service account key file containing
     * the credentials required to use Google PubSub.
     * Deprecated: This field is deprecated and replaced by \"serviceAccountKeyFileSecretId\". This field will be removed after February 15 2026.
     *
     */
    "serviceAccountKeyFile": string;
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Secret where the content of the service account key file is stored,
     * which contains the credentials required to use Google PubSub.
     * Note: When provided, 'serviceAccountKeyFile' field must not be provided.
     *
     */
    "serviceAccountKeyFileSecretId"?: string;
    "connectionType": string;
}
export declare namespace CreateGooglePubSubConnectionDetails {
    function getJsonObj(obj: CreateGooglePubSubConnectionDetails, isParentJsonObj?: boolean): object;
    const connectionType = "GOOGLE_PUBSUB";
    function getDeserializedJsonObj(obj: CreateGooglePubSubConnectionDetails, isParentJsonObj?: boolean): object;
}
