/**
 * GoldenGate API
 * Use the Oracle Cloud Infrastructure GoldenGate APIs to perform data replication operations.

 * OpenAPI spec version: 20200407
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The summary of the deployment Peer.
 *
 */
export interface DeploymentPeerSummary {
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the deployment being referenced.
     *
     */
    "deploymentId": string;
    /**
     * The name of the region. e.g.: us-ashburn-1
     * If the region is not provided, backend will default to the default region.
     *
     */
    "region": string;
    /**
     * The availability domain of a placement.
     */
    "availabilityDomain": string;
    /**
     * The fault domain of a placement.
     */
    "faultDomain": string;
    /**
     * An object's Display Name.
     *
     */
    "displayName": string;
    /**
     * The type of the deployment peer.
     *
     */
    "peerType": model.DeploymentPeerType;
    /**
     * The type of the deployment role.
     *
     */
    "peerRole": model.DeploymentRole;
    /**
     * The time the resource was created. The format is defined by
     * [RFC3339](https://tools.ietf.org/html/rfc3339), such as {@code 2016-08-25T21:10:29.600Z}.
     *
     */
    "timeCreated": Date;
    /**
     * The time the resource was last updated. The format is defined by
     * [RFC3339](https://tools.ietf.org/html/rfc3339), such as {@code 2016-08-25T21:10:29.600Z}.
     *
     */
    "timeUpdated": Date;
    /**
     * The time of the last role change. The format is defined by
     * [RFC3339](https://tools.ietf.org/html/rfc3339), such as {@code 2016-08-25T21:10:29.600Z}.
     *
     */
    "timeRoleChanged": Date;
    /**
     * Possible lifecycle states for deployment peer.
     */
    "lifecycleState": DeploymentPeerSummary.LifecycleState;
}
export declare namespace DeploymentPeerSummary {
    enum LifecycleState {
        Creating = "CREATING",
        Active = "ACTIVE",
        Failed = "FAILED",
        Updating = "UPDATING",
        Deleting = "DELETING",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: DeploymentPeerSummary): object;
    function getDeserializedJsonObj(obj: DeploymentPeerSummary): object;
}
