"use strict";
/**
 * GoldenGate API
 * Use the Oracle Cloud Infrastructure GoldenGate APIs to perform data replication operations.

 * OpenAPI spec version: 20200407
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IcebergStorage = void 0;
const model = __importStar(require("../model"));
const common = require("oci-common");
var IcebergStorage;
(function (IcebergStorage) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {});
        if (obj && "storageType" in obj && obj.storageType) {
            switch (obj.storageType) {
                case "AMAZON_S3":
                    return model.AmazonS3IcebergStorage.getJsonObj(jsonObj, true);
                case "AZURE_DATA_LAKE_STORAGE":
                    return model.AzureDataLakeStorageIcebergStorage.getJsonObj(jsonObj, true);
                case "GOOGLE_CLOUD_STORAGE":
                    return model.GoogleCloudStorageIcebergStorage.getJsonObj(jsonObj, true);
                default:
                    if (common.LOG.logger)
                        common.LOG.logger.info(`Unknown value for: ${obj.storageType}`);
            }
        }
        return jsonObj;
    }
    IcebergStorage.getJsonObj = getJsonObj;
    function getDeserializedJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {});
        if (obj && "storageType" in obj && obj.storageType) {
            switch (obj.storageType) {
                case "AMAZON_S3":
                    return model.AmazonS3IcebergStorage.getDeserializedJsonObj(jsonObj, true);
                case "AZURE_DATA_LAKE_STORAGE":
                    return model.AzureDataLakeStorageIcebergStorage.getDeserializedJsonObj(jsonObj, true);
                case "GOOGLE_CLOUD_STORAGE":
                    return model.GoogleCloudStorageIcebergStorage.getDeserializedJsonObj(jsonObj, true);
                default:
                    if (common.LOG.logger)
                        common.LOG.logger.info(`Unknown value for: ${obj.storageType}`);
            }
        }
        return jsonObj;
    }
    IcebergStorage.getDeserializedJsonObj = getDeserializedJsonObj;
})(IcebergStorage = exports.IcebergStorage || (exports.IcebergStorage = {}));
//# sourceMappingURL=iceberg-storage.js.map