/**
 * GoldenGate API
 * Use the Oracle Cloud Infrastructure GoldenGate APIs to perform data replication operations.

 * OpenAPI spec version: 20200407
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Summary of the Polaris catalog used in the Iceberg connection.
 *
 */
export interface PolarisIcebergCatalogSummary extends model.IcebergCatalogSummary {
    /**
     * The URL endpoint for the Polaris API.
     * e.g.: 'https://<your-snowflake-account>.snowflakecomputing.com/polaris/api/catalog'
     *
     */
    "uri": string;
    /**
     * The catalog name within Polaris where Iceberg tables are registered.
     */
    "name": string;
    /**
     * The OAuth client ID used for authentication.
     */
    "clientId": string;
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Secret that stores the password Oracle GoldenGate uses to connect to Snowflake platform.
     *
     */
    "clientSecretSecretId": string;
    /**
     * The Snowflake role used to access Polaris.
     */
    "principalRole": string;
    "catalogType": string;
}
export declare namespace PolarisIcebergCatalogSummary {
    function getJsonObj(obj: PolarisIcebergCatalogSummary, isParentJsonObj?: boolean): object;
    const catalogType = "POLARIS";
    function getDeserializedJsonObj(obj: PolarisIcebergCatalogSummary, isParentJsonObj?: boolean): object;
}
