/**
 * GoldenGate API
 * Use the Oracle Cloud Infrastructure GoldenGate APIs to perform data replication operations.

 * OpenAPI spec version: 20200407
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Represents a Rest catalog used in the Iceberg connection.
 *
 */
export interface RestIcebergCatalog extends model.IcebergCatalog {
    /**
     * The base URL for the REST Catalog API.
     * e.g.: 'https://my-rest-catalog.example.com/api/v1'
     *
     */
    "uri": string;
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Secret that stores the content
     * of the configuration file containing additional properties for the REST catalog.
     * See documentation: https://docs.oracle.com/en-us/iaas/Content/Identity/Tasks/managingcredentials.htm
     *
     */
    "propertiesSecretId": string;
    "catalogType": string;
}
export declare namespace RestIcebergCatalog {
    function getJsonObj(obj: RestIcebergCatalog, isParentJsonObj?: boolean): object;
    const catalogType = "REST";
    function getDeserializedJsonObj(obj: RestIcebergCatalog, isParentJsonObj?: boolean): object;
}
