/**
 * GoldenGate API
 * Use the Oracle Cloud Infrastructure GoldenGate APIs to perform data replication operations.

 * OpenAPI spec version: 20200407
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The information to update the Azure Data Lake Storage storage used in the Iceberg connection.
 *
 */
export interface UpdateAzureDataLakeStorageIcebergStorageDetails extends model.UpdateIcebergStorageDetails {
    /**
     * Sets the Azure storage account name.
     *
     */
    "accountName"?: string;
    /**
     * The Azure Blob Storage container where Iceberg tables are stored.
     */
    "container"?: string;
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Secret where the account key is stored.
     *
     */
    "accountKeySecretId"?: string;
    /**
     * The Azure Blob Storage endpoint where Iceberg data is stored.
     * e.g.: 'https://my-azure-storage-account.blob.core.windows.net'
     *
     */
    "endpoint"?: string;
    "storageType": string;
}
export declare namespace UpdateAzureDataLakeStorageIcebergStorageDetails {
    function getJsonObj(obj: UpdateAzureDataLakeStorageIcebergStorageDetails, isParentJsonObj?: boolean): object;
    const storageType = "AZURE_DATA_LAKE_STORAGE";
    function getDeserializedJsonObj(obj: UpdateAzureDataLakeStorageIcebergStorageDetails, isParentJsonObj?: boolean): object;
}
