/**
 * GoldenGate API
 * Use the Oracle Cloud Infrastructure GoldenGate APIs to perform data replication operations.

 * OpenAPI spec version: 20200407
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The information to update the Google Cloud Storage storage used in the Iceberg connection.
 *
 */
export interface UpdateGoogleCloudStorageIcebergStorageDetails extends model.UpdateIcebergStorageDetails {
    /**
     * Google Cloud Storage bucket where Iceberg stores metadata and data files.
     */
    "bucket"?: string;
    /**
     * The Google Cloud Project where the bucket exists.
     */
    "projectId"?: string;
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Secret where the content of the service account key file is stored,
     * which contains the credentials required to use Google Cloud Storage.
     *
     */
    "serviceAccountKeyFileSecretId"?: string;
    "storageType": string;
}
export declare namespace UpdateGoogleCloudStorageIcebergStorageDetails {
    function getJsonObj(obj: UpdateGoogleCloudStorageIcebergStorageDetails, isParentJsonObj?: boolean): object;
    const storageType = "GOOGLE_CLOUD_STORAGE";
    function getDeserializedJsonObj(obj: UpdateGoogleCloudStorageIcebergStorageDetails, isParentJsonObj?: boolean): object;
}
