/**
 * Java Management Service Fleets API
 * The APIs for the [Fleet Management](https://docs.oracle.com/en-us/iaas/jms/doc/fleet-management.html) feature of Java Management Service to monitor and manage the usage of Java in your enterprise. Use these APIs to manage fleets, configure managed instances to report to fleets, and gain insights into the Java workloads running on these instances by carrying out basic and advanced features.
 * OpenAPI spec version: 20210610
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The essential properties to identify a Java Runtime.
 */
export interface JavaRuntimeId {
    /**
     * The version of the Java Runtime.
     */
    "version": string;
    /**
     * The vendor of the Java Runtime.
     */
    "vendor": string;
    /**
     * The distribution of a Java Runtime is the name of the lineage of product to which it belongs, for example _Java(TM) SE Runtime Environment_.
     */
    "distribution": string;
    /**
     * The unique identifier for a Java Runtime.
     */
    "jreKey"?: string;
}
export declare namespace JavaRuntimeId {
    function getJsonObj(obj: JavaRuntimeId): object;
    function getDeserializedJsonObj(obj: JavaRuntimeId): object;
}
