/**
 *
 *
 * OpenAPI spec version: 20210610
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/jms/ListFleetErrors.ts.html |here} to see how to use ListFleetErrorsRequest.
 */
export interface ListFleetErrorsRequest extends common.BaseRequest {
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment in which to list resources.
     *
     */
    "compartmentId"?: string;
    /**
     * Flag to determine whether the info should be gathered only in the compartment or in the compartment and its subcompartments.
     *
     */
    "compartmentIdInSubtree"?: boolean;
    /**
     * The ID of the Fleet.
     */
    "fleetId"?: string;
    /**
     * If specified, only errors with a first seen time earlier than this parameter will be included in the search (formatted according to RFC3339).
     */
    "timeFirstSeenLessThanOrEqualTo"?: Date;
    /**
     * If specified, only errors with a first seen time later than this parameter will be included in the search (formatted according to RFC3339).
     */
    "timeFirstSeenGreaterThanOrEqualTo"?: Date;
    /**
     * If specified, only errors with a last seen time earlier than this parameter will be included in the search (formatted according to RFC3339).
     */
    "timeLastSeenLessThanOrEqualTo"?: Date;
    /**
     * If specified, only errors with a last seen time later than this parameter will be included in the search (formatted according to RFC3339).
     */
    "timeLastSeenGreaterThanOrEqualTo"?: Date;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. The token is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The field to sort FleetError. Only one sort order may be provided.
     * Default order is **descending**.
     * If no value is specified _timeLastSeen_ is default.
     *
     */
    "sortBy"?: model.FleetErrorSortBy;
    /**
     * The sort order, either 'asc' or 'desc'.
     */
    "sortOrder"?: model.SortOrder;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
