/**
 * Java Management Service Fleets API
 * The APIs for the [Fleet Management](https://docs.oracle.com/en-us/iaas/jms/doc/fleet-management.html) feature of Java Management Service to monitor and manage the usage of Java in your enterprise. Use these APIs to manage fleets, configure managed instances to report to fleets, and gain insights into the Java workloads running on these instances by carrying out basic and advanced features.
 * OpenAPI spec version: 20210610
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as AddFleetInstallationSitesResponse from "./add-fleet-installation-sites-response";
export import AddFleetInstallationSitesResponse = AddFleetInstallationSitesResponse.AddFleetInstallationSitesResponse;
import * as CancelWorkRequestResponse from "./cancel-work-request-response";
export import CancelWorkRequestResponse = CancelWorkRequestResponse.CancelWorkRequestResponse;
import * as ChangeFleetCompartmentResponse from "./change-fleet-compartment-response";
export import ChangeFleetCompartmentResponse = ChangeFleetCompartmentResponse.ChangeFleetCompartmentResponse;
import * as CreateBlocklistResponse from "./create-blocklist-response";
export import CreateBlocklistResponse = CreateBlocklistResponse.CreateBlocklistResponse;
import * as CreateDrsFileResponse from "./create-drs-file-response";
export import CreateDrsFileResponse = CreateDrsFileResponse.CreateDrsFileResponse;
import * as CreateFleetResponse from "./create-fleet-response";
export import CreateFleetResponse = CreateFleetResponse.CreateFleetResponse;
import * as CreateJmsPluginResponse from "./create-jms-plugin-response";
export import CreateJmsPluginResponse = CreateJmsPluginResponse.CreateJmsPluginResponse;
import * as DeleteBlocklistResponse from "./delete-blocklist-response";
export import DeleteBlocklistResponse = DeleteBlocklistResponse.DeleteBlocklistResponse;
import * as DeleteCryptoAnalysisResultResponse from "./delete-crypto-analysis-result-response";
export import DeleteCryptoAnalysisResultResponse = DeleteCryptoAnalysisResultResponse.DeleteCryptoAnalysisResultResponse;
import * as DeleteDrsFileResponse from "./delete-drs-file-response";
export import DeleteDrsFileResponse = DeleteDrsFileResponse.DeleteDrsFileResponse;
import * as DeleteFleetResponse from "./delete-fleet-response";
export import DeleteFleetResponse = DeleteFleetResponse.DeleteFleetResponse;
import * as DeleteJavaMigrationAnalysisResultResponse from "./delete-java-migration-analysis-result-response";
export import DeleteJavaMigrationAnalysisResultResponse = DeleteJavaMigrationAnalysisResultResponse.DeleteJavaMigrationAnalysisResultResponse;
import * as DeleteJmsPluginResponse from "./delete-jms-plugin-response";
export import DeleteJmsPluginResponse = DeleteJmsPluginResponse.DeleteJmsPluginResponse;
import * as DeletePerformanceTuningAnalysisResultResponse from "./delete-performance-tuning-analysis-result-response";
export import DeletePerformanceTuningAnalysisResultResponse = DeletePerformanceTuningAnalysisResultResponse.DeletePerformanceTuningAnalysisResultResponse;
import * as DisableDrsResponse from "./disable-drs-response";
export import DisableDrsResponse = DisableDrsResponse.DisableDrsResponse;
import * as EnableDrsResponse from "./enable-drs-response";
export import EnableDrsResponse = EnableDrsResponse.EnableDrsResponse;
import * as GenerateAgentDeployScriptResponse from "./generate-agent-deploy-script-response";
export import GenerateAgentDeployScriptResponse = GenerateAgentDeployScriptResponse.GenerateAgentDeployScriptResponse;
import * as GenerateAgentInstallerConfigurationResponse from "./generate-agent-installer-configuration-response";
export import GenerateAgentInstallerConfigurationResponse = GenerateAgentInstallerConfigurationResponse.GenerateAgentInstallerConfigurationResponse;
import * as GenerateLoadPipelineScriptResponse from "./generate-load-pipeline-script-response";
export import GenerateLoadPipelineScriptResponse = GenerateLoadPipelineScriptResponse.GenerateLoadPipelineScriptResponse;
import * as GetCryptoAnalysisResultResponse from "./get-crypto-analysis-result-response";
export import GetCryptoAnalysisResultResponse = GetCryptoAnalysisResultResponse.GetCryptoAnalysisResultResponse;
import * as GetDrsFileResponse from "./get-drs-file-response";
export import GetDrsFileResponse = GetDrsFileResponse.GetDrsFileResponse;
import * as GetExportSettingResponse from "./get-export-setting-response";
export import GetExportSettingResponse = GetExportSettingResponse.GetExportSettingResponse;
import * as GetExportStatusResponse from "./get-export-status-response";
export import GetExportStatusResponse = GetExportStatusResponse.GetExportStatusResponse;
import * as GetFleetResponse from "./get-fleet-response";
export import GetFleetResponse = GetFleetResponse.GetFleetResponse;
import * as GetFleetAdvancedFeatureConfigurationResponse from "./get-fleet-advanced-feature-configuration-response";
export import GetFleetAdvancedFeatureConfigurationResponse = GetFleetAdvancedFeatureConfigurationResponse.GetFleetAdvancedFeatureConfigurationResponse;
import * as GetFleetAgentConfigurationResponse from "./get-fleet-agent-configuration-response";
export import GetFleetAgentConfigurationResponse = GetFleetAgentConfigurationResponse.GetFleetAgentConfigurationResponse;
import * as GetJavaFamilyResponse from "./get-java-family-response";
export import GetJavaFamilyResponse = GetJavaFamilyResponse.GetJavaFamilyResponse;
import * as GetJavaMigrationAnalysisResultResponse from "./get-java-migration-analysis-result-response";
export import GetJavaMigrationAnalysisResultResponse = GetJavaMigrationAnalysisResultResponse.GetJavaMigrationAnalysisResultResponse;
import * as GetJavaReleaseResponse from "./get-java-release-response";
export import GetJavaReleaseResponse = GetJavaReleaseResponse.GetJavaReleaseResponse;
import * as GetJmsPluginResponse from "./get-jms-plugin-response";
export import GetJmsPluginResponse = GetJmsPluginResponse.GetJmsPluginResponse;
import * as GetPerformanceTuningAnalysisResultResponse from "./get-performance-tuning-analysis-result-response";
export import GetPerformanceTuningAnalysisResultResponse = GetPerformanceTuningAnalysisResultResponse.GetPerformanceTuningAnalysisResultResponse;
import * as GetWorkRequestResponse from "./get-work-request-response";
export import GetWorkRequestResponse = GetWorkRequestResponse.GetWorkRequestResponse;
import * as ListAgentInstallersResponse from "./list-agent-installers-response";
export import ListAgentInstallersResponse = ListAgentInstallersResponse.ListAgentInstallersResponse;
import * as ListAnnouncementsResponse from "./list-announcements-response";
export import ListAnnouncementsResponse = ListAnnouncementsResponse.ListAnnouncementsResponse;
import * as ListBlocklistsResponse from "./list-blocklists-response";
export import ListBlocklistsResponse = ListBlocklistsResponse.ListBlocklistsResponse;
import * as ListCryptoAnalysisResultsResponse from "./list-crypto-analysis-results-response";
export import ListCryptoAnalysisResultsResponse = ListCryptoAnalysisResultsResponse.ListCryptoAnalysisResultsResponse;
import * as ListDrsFilesResponse from "./list-drs-files-response";
export import ListDrsFilesResponse = ListDrsFilesResponse.ListDrsFilesResponse;
import * as ListFleetDiagnosesResponse from "./list-fleet-diagnoses-response";
export import ListFleetDiagnosesResponse = ListFleetDiagnosesResponse.ListFleetDiagnosesResponse;
import * as ListFleetErrorsResponse from "./list-fleet-errors-response";
export import ListFleetErrorsResponse = ListFleetErrorsResponse.ListFleetErrorsResponse;
import * as ListFleetsResponse from "./list-fleets-response";
export import ListFleetsResponse = ListFleetsResponse.ListFleetsResponse;
import * as ListInstallationSitesResponse from "./list-installation-sites-response";
export import ListInstallationSitesResponse = ListInstallationSitesResponse.ListInstallationSitesResponse;
import * as ListJavaFamiliesResponse from "./list-java-families-response";
export import ListJavaFamiliesResponse = ListJavaFamiliesResponse.ListJavaFamiliesResponse;
import * as ListJavaMigrationAnalysisResultsResponse from "./list-java-migration-analysis-results-response";
export import ListJavaMigrationAnalysisResultsResponse = ListJavaMigrationAnalysisResultsResponse.ListJavaMigrationAnalysisResultsResponse;
import * as ListJavaReleasesResponse from "./list-java-releases-response";
export import ListJavaReleasesResponse = ListJavaReleasesResponse.ListJavaReleasesResponse;
import * as ListJmsPluginsResponse from "./list-jms-plugins-response";
export import ListJmsPluginsResponse = ListJmsPluginsResponse.ListJmsPluginsResponse;
import * as ListJreUsageResponse from "./list-jre-usage-response";
export import ListJreUsageResponse = ListJreUsageResponse.ListJreUsageResponse;
import * as ListPerformanceTuningAnalysisResultsResponse from "./list-performance-tuning-analysis-results-response";
export import ListPerformanceTuningAnalysisResultsResponse = ListPerformanceTuningAnalysisResultsResponse.ListPerformanceTuningAnalysisResultsResponse;
import * as ListPluginErrorsResponse from "./list-plugin-errors-response";
export import ListPluginErrorsResponse = ListPluginErrorsResponse.ListPluginErrorsResponse;
import * as ListWorkItemsResponse from "./list-work-items-response";
export import ListWorkItemsResponse = ListWorkItemsResponse.ListWorkItemsResponse;
import * as ListWorkRequestErrorsResponse from "./list-work-request-errors-response";
export import ListWorkRequestErrorsResponse = ListWorkRequestErrorsResponse.ListWorkRequestErrorsResponse;
import * as ListWorkRequestLogsResponse from "./list-work-request-logs-response";
export import ListWorkRequestLogsResponse = ListWorkRequestLogsResponse.ListWorkRequestLogsResponse;
import * as ListWorkRequestsResponse from "./list-work-requests-response";
export import ListWorkRequestsResponse = ListWorkRequestsResponse.ListWorkRequestsResponse;
import * as RemoveFleetInstallationSitesResponse from "./remove-fleet-installation-sites-response";
export import RemoveFleetInstallationSitesResponse = RemoveFleetInstallationSitesResponse.RemoveFleetInstallationSitesResponse;
import * as RequestCryptoAnalysesResponse from "./request-crypto-analyses-response";
export import RequestCryptoAnalysesResponse = RequestCryptoAnalysesResponse.RequestCryptoAnalysesResponse;
import * as RequestDeployedApplicationMigrationAnalysesResponse from "./request-deployed-application-migration-analyses-response";
export import RequestDeployedApplicationMigrationAnalysesResponse = RequestDeployedApplicationMigrationAnalysesResponse.RequestDeployedApplicationMigrationAnalysesResponse;
import * as RequestJavaMigrationAnalysesResponse from "./request-java-migration-analyses-response";
export import RequestJavaMigrationAnalysesResponse = RequestJavaMigrationAnalysesResponse.RequestJavaMigrationAnalysesResponse;
import * as RequestJfrRecordingsResponse from "./request-jfr-recordings-response";
export import RequestJfrRecordingsResponse = RequestJfrRecordingsResponse.RequestJfrRecordingsResponse;
import * as RequestPerformanceTuningAnalysesResponse from "./request-performance-tuning-analyses-response";
export import RequestPerformanceTuningAnalysesResponse = RequestPerformanceTuningAnalysesResponse.RequestPerformanceTuningAnalysesResponse;
import * as ScanJavaServerUsageResponse from "./scan-java-server-usage-response";
export import ScanJavaServerUsageResponse = ScanJavaServerUsageResponse.ScanJavaServerUsageResponse;
import * as ScanLibraryUsageResponse from "./scan-library-usage-response";
export import ScanLibraryUsageResponse = ScanLibraryUsageResponse.ScanLibraryUsageResponse;
import * as SummarizeApplicationInstallationUsageResponse from "./summarize-application-installation-usage-response";
export import SummarizeApplicationInstallationUsageResponse = SummarizeApplicationInstallationUsageResponse.SummarizeApplicationInstallationUsageResponse;
import * as SummarizeApplicationUsageResponse from "./summarize-application-usage-response";
export import SummarizeApplicationUsageResponse = SummarizeApplicationUsageResponse.SummarizeApplicationUsageResponse;
import * as SummarizeDeployedApplicationInstallationUsageResponse from "./summarize-deployed-application-installation-usage-response";
export import SummarizeDeployedApplicationInstallationUsageResponse = SummarizeDeployedApplicationInstallationUsageResponse.SummarizeDeployedApplicationInstallationUsageResponse;
import * as SummarizeDeployedApplicationUsageResponse from "./summarize-deployed-application-usage-response";
export import SummarizeDeployedApplicationUsageResponse = SummarizeDeployedApplicationUsageResponse.SummarizeDeployedApplicationUsageResponse;
import * as SummarizeFleetErrorsResponse from "./summarize-fleet-errors-response";
export import SummarizeFleetErrorsResponse = SummarizeFleetErrorsResponse.SummarizeFleetErrorsResponse;
import * as SummarizeInstallationUsageResponse from "./summarize-installation-usage-response";
export import SummarizeInstallationUsageResponse = SummarizeInstallationUsageResponse.SummarizeInstallationUsageResponse;
import * as SummarizeJavaServerInstanceUsageResponse from "./summarize-java-server-instance-usage-response";
export import SummarizeJavaServerInstanceUsageResponse = SummarizeJavaServerInstanceUsageResponse.SummarizeJavaServerInstanceUsageResponse;
import * as SummarizeJavaServerUsageResponse from "./summarize-java-server-usage-response";
export import SummarizeJavaServerUsageResponse = SummarizeJavaServerUsageResponse.SummarizeJavaServerUsageResponse;
import * as SummarizeJreUsageResponse from "./summarize-jre-usage-response";
export import SummarizeJreUsageResponse = SummarizeJreUsageResponse.SummarizeJreUsageResponse;
import * as SummarizeLibraryUsageResponse from "./summarize-library-usage-response";
export import SummarizeLibraryUsageResponse = SummarizeLibraryUsageResponse.SummarizeLibraryUsageResponse;
import * as SummarizeManagedInstanceUsageResponse from "./summarize-managed-instance-usage-response";
export import SummarizeManagedInstanceUsageResponse = SummarizeManagedInstanceUsageResponse.SummarizeManagedInstanceUsageResponse;
import * as SummarizePluginErrorsResponse from "./summarize-plugin-errors-response";
export import SummarizePluginErrorsResponse = SummarizePluginErrorsResponse.SummarizePluginErrorsResponse;
import * as SummarizeResourceInventoryResponse from "./summarize-resource-inventory-response";
export import SummarizeResourceInventoryResponse = SummarizeResourceInventoryResponse.SummarizeResourceInventoryResponse;
import * as UpdateDrsFileResponse from "./update-drs-file-response";
export import UpdateDrsFileResponse = UpdateDrsFileResponse.UpdateDrsFileResponse;
import * as UpdateExportSettingResponse from "./update-export-setting-response";
export import UpdateExportSettingResponse = UpdateExportSettingResponse.UpdateExportSettingResponse;
import * as UpdateFleetResponse from "./update-fleet-response";
export import UpdateFleetResponse = UpdateFleetResponse.UpdateFleetResponse;
import * as UpdateFleetAdvancedFeatureConfigurationResponse from "./update-fleet-advanced-feature-configuration-response";
export import UpdateFleetAdvancedFeatureConfigurationResponse = UpdateFleetAdvancedFeatureConfigurationResponse.UpdateFleetAdvancedFeatureConfigurationResponse;
import * as UpdateFleetAgentConfigurationResponse from "./update-fleet-agent-configuration-response";
export import UpdateFleetAgentConfigurationResponse = UpdateFleetAgentConfigurationResponse.UpdateFleetAgentConfigurationResponse;
import * as UpdateJmsPluginResponse from "./update-jms-plugin-response";
export import UpdateJmsPluginResponse = UpdateJmsPluginResponse.UpdateJmsPluginResponse;
