/**
 *
 *
 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/// <reference types="node" />
import common = require("oci-common");
import stream = require("stream");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/loganalytics/UploadOtlpLogs.ts.html |here} to see how to use UploadOtlpLogsRequest.
 */
export interface UploadOtlpLogsRequest extends common.BaseRequest {
    /**
     * The Logging Analytics namespace used for the request.
     *
     */
    "namespaceName": string;
    /**
     * The log group OCID to which the log data in this upload will be mapped to.
     *
     */
    "opcMetaLoggrpid": string;
    /**
     * Accepts log data in OTLP JSON-encoded Protobuf format.
     * Sample format: https://github.com/open-telemetry/opentelemetry-proto/blob/v1.3.1/examples/logs.json
     *
     */
    "uploadOtlpLogsDetails": Uint8Array | Buffer | Blob | stream.Readable | ReadableStream | string;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
    /**
     * The log set that gets associated with the uploaded logs.
     *
     */
    "logSet"?: string;
    /**
     * The content type of the log data.
     */
    "contentType"?: string;
    /**
     * A token that uniquely identifies a request so it can be retried in case of a timeout or
     * server error without risk of executing that same action again. Retry tokens expire after 24
     * hours, but can be invalidated before then due to conflicting operations. For example, if a resource
     * has been deleted and purged from the system, then a retry of the original creation request
     * might be rejected.
     *
     */
    "opcRetryToken"?: string;
    /**
     * Metadata key and value pairs separated by a semicolon. Example k1:v1;k2:v2;k3:v3
     *
     */
    "opcMetaProperties"?: string;
    /**
     * A value of {@code 100-continue} requests preliminary verification of the request method, path, and headers before the request body is sent.
     * If no error results from such verification, the server will send a 100 (Continue) interim response to indicate readiness for the request body.
     * The only allowed value for this parameter is \"100-Continue\" (case-insensitive).
     *
     */
    "expect"?: string;
}
