/**
 * Dblm API
 * A description of the Dblm API
 * OpenAPI spec version: 20240102
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Summary of vulnerabilities found in registered resources grouped by severity.
 */
export interface VulnerabilitiesSummary {
    /**
     * Total number of vulnerabilities. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "total": number;
    /**
     * Cumulative number of resources that have critical level vulnerabilities. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "critical": number;
    /**
     * Cumulative number of resources that have high level vulnerabilities. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "high": number;
    /**
     * Cumulative number of resources that have medium level vulnerabilities. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "medium": number;
    /**
     * Cumulative number of resources that have info level vulnerabilities. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "info": number;
    /**
     * Cumulative number of resources that have low level vulnerabilities. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "low": number;
}
export declare namespace VulnerabilitiesSummary {
    function getJsonObj(obj: VulnerabilitiesSummary): object;
    function getDeserializedJsonObj(obj: VulnerabilitiesSummary): object;
}
